;--------------------------
; makro pro porovnani registru s konstantou
; pokud je registr roven konstante, provede se nasledujici instrukce

iffeq	macro	reg, const
	movlw	const
	subwf	reg,0
	btfsc	STATUS,Z
	endm

;--------------------------
; makro pro porovnani registru s konstantou
; pokud registr neni roven konstante, provede se nasledujici instrukce

iffneq	macro	reg, const
	movlw	const
	subwf	reg,0
	btfss	STATUS,Z
	endm
	
;--------------------------
; makro pro porovnani registru s konstantou
; pokud je registr vetsi nebo rovny konstante, pokud ano provede se nasledujici instrukce

iffhieq	macro	reg, const
	movlw	const
	subwf	reg,0
	btfsc	STATUS,C
	endm

;--------------------------
; makro pro porovnani registru s konstantou
; pokud je registr vetsi nez konstanta, pokud ano provede se nasledujici instrukce

iffhi	macro	reg, const
	movf	reg,W
	sublw	const
	btfss	STATUS,C
	endm
	
;--------------------------
; makro pro porovnani registru s konstantou
; pokud je registr mensi nez konstanta, pokud ano provede se nasledujici instrukce

ifflo	macro	reg, const
	movlw	const
	subwf	reg,0
	btfss	STATUS,C
	endm

;--------------------------
; makro pro porovnani registru s konstantou
; pokud je registr mensi nebo rovny konstante, pokud ano provede se nasledujici instrukce

iffloeq	macro	reg, const
	movf	reg,W
	sublw	const
	btfsc	STATUS,C
	endm
	
;--------------------------
; makro pro porovnani registru s jinym registrem
; pokud je registr vetsi nez druhy registr, provede se nasledujici instrukce

iffhif	macro	reg, reg2
	movf	reg,W
	subwf	reg2,W
	btfss	STATUS,C
	endm
	
;--------------------------
; makro pro porovnani registru s jinym registrem
; pokud je registr mensi nez druhy registr, provede se nasledujici instrukce

ifflof	macro	reg, reg2
	movf	reg2,W
	subwf	reg,W
	btfss	STATUS,C
	endm
	
;--------------------------
; makro pro porovnani jednoho registru s druhym
; pokud jsou si registry rovny, provede se nasledujici instrukce
	
iffeqf	macro	reg, reg2
	movf	reg,W
	subwf	reg2,W
	btfsc	STATUS,Z
	endm
	
;--------------------------
; makro pro porovnani jednoho registru s druhym
; pokud si registry nejsou rovny, provede se nasledujici instrukce
	
iffneqf	macro	reg, reg2
	movf	reg,W
	subwf	reg2,W
	btfss	STATUS,Z
	endm	

;--------------------------
; makro pro vlozeni konstanty do registru
	
movl	macro	reg,const	
	movlw	const
	movwf	reg
	endm

;--------------------------
; makro pro presun dat z registru do registru
	
mov	macro	reg1,reg2	
	movf	reg1,W
	movwf	reg2
	endm	
