include <p16f873.inc>
include <dd16fx.inc>

__config _LVP_OFF & _XT_OSC & _WDT_OFF & _PWRTE_ON & _CP_OFF & _BODEN_OFF

#define BUTMODE PORTB,3

PC	equ	02h
;PORTA	EQU	05h
;PORTB	EQU	06h

tmp	EQU	20h
tmp1	EQU	21h
num	equ	22h
u	equ	23h
mem	equ	24h
count	equ	25h
acch	equ	26h
acc	equ	27h
min	equ	28h
min2	equ	29h
f1	equ	2ah
f2	equ	2bh
f3	equ	2ch
f4	equ	2dh
f16h	equ	2eh
f16l	equ	2fh
phase	equ	30h
dprm	equ	31h		
chng	equ	32h  	; priznak zobrazeni desetinne tecky
ev	equ	33h	; hodnota ev (v pulstupnich, takze vlastne ev*2)
asa	equ	34h	; citlivost filmu (v tretinach ASA, co 1 dil, to 1/3 ASA, zacatek na 25)
mode	equ	35h	; cinnost (0..expozimetr, 1..flashmetr, 2..nastaveni ISO)
av	equ	36h	; clona
tv	equ	37h	; cas
charadr	equ	38h
count2	equ	39h
adr1	equ	3Ah
charnum	equ	3Bh
mmode	equ	3Ch	; rezim mereni (Av, Tv)
calmode	equ	3Dh	; rezim kalibrace (Expo, Flash)
step	equ	3Fh	; krok EV (1..EV/2, 2..EV/3)
line1	equ	40h	; 8 znaku na 1. radku
line2	equ	48h	; 8 znaku na 2. radku
temp0   equ     3Eh
temp1   equ     50h
temp2   equ     51h
temp3   equ     52h
temp4   equ     53h
temp5   equ     54h
temp6   equ     55h
temp7   equ     56h
temp8   equ     57h
temp9   equ     58h
nk	equ	59h	; pocet mereni pri kalibraci
sumxh	equ	5Ah
sumxl	equ	5Bh
sumyh	equ	5Ch
sumyl	equ	5Dh
sumxyh2	equ	5Eh
sumxyh	equ	5Fh
sumxyl	equ	60h
sumxxh	equ	61h
sumxxl	equ	62h
sumx2h	equ	2eh	; prekryva se s f16h
sumx2l	equ	2fh	; prekryva se s f16l
a1h	equ	63h
a1	equ	64h	; parametr a zavislosti ev a napeti (u=a*ev+b)
b1h	equ	65h
b1	equ	66h	; parametr a zavislosti ev a napeti (u=a*ev+b)
ae3	equ	75h	; parametr a zavislosti ev a napeti pro expozimetr (u=a*ev+b) pro krok 1/3 EV
be	equ	76h	; parametr b zavislosti ev a napeti pro expozimetr (u=a*ev+b)  
af3	equ	77h	; parametr a zavislosti ev a napeti pro flashmetr (u=a*ev+b) pro krok 1/3 EV
bf	equ	78h	; parametr b zavislosti ev a napeti pro flashmetr (u=a*ev+b) 
ae2	equ	67h	; parametr a zavislosti ev a napeti pro expozimetr (u=a*ev+b) pro krok 1/2 EV
;be2	equ	68h	; parametr a zavislosti ev a napeti pro expozimetr (u=a*ev+b) pro krok 1/2 EV
af2	equ	69h	; parametr a zavislosti ev a napeti pro flashmetr (u=a*ev+b) pro krok 1/2 EV
;bf2	equ	6Ah	; parametr a zavislosti ev a napeti pro flashmetr (u=a*ev+b) pro krok 1/2 EV
x	equ	5Eh	; hodnota vypoctena ze zavislosti
rep	equ	5Fh	; pricitaci konstanta (kalibrace byla pri 100 ASA, cas 1/60 s)
asar	equ	6Bh	; redukovane EV pro krok 1/2 EV
maxav	equ	6Ch	; maximalni hodnota clony
maxtv	equ	6Dh	; maximalni hodnota casu
overf	equ	6Eh	; priznak podteceni/preteceni hodnoty
at	equ	6Fh	; parametr a zavislosti teploty a zmeny napeti (tempu=at*(delta u)+b)
cetemp	equ	70h	; namerena teplota pri kalibraci expozimetru
avf	equ	71h	; hodnota clony od blesk. svetla
ava	equ	72h	; hodnota clony od denniho svetla
flsens	equ	73h	; citlivost flashmetru
calbat	equ	74h	; napeti baterie, ktere uz je brano jako nizke
fcount	equ	79h	; pocet mereni behem zablesku
cftemp	equ	7Ah	; namerena teplota pri kalibraci flashmetru
negbf	equ	7Bh	; priznak, ze parametr b v zavislosti ma zapornou hodnotu
negb	equ	7Ch	; aktualni parametr b v zavislosti ma zapornou hodnotu - priznak pro probihajici vypocet
caltemp	equ	21h	; teplota pri kalibraci (cetemp nebo cftemp podle modu), prekryva se s tmp1
halff	equ	7Dh	; zablesk konci uz v polovine rozdilu max-min

; bank 1:
tline	equ	0A0h	; pomocny radek pro 8 znaku
tmp2	equ	0A8h	; pomocna promenna
calav	equ	0B0h	; pole pro zmerene clony pri kalibraci
calu	equ	0C0h	; pole pro zmerena napeti pri kalibraci

LCD_E	EQU	2	; LCD Enable control line
LCD_RW	EQU	1	; LCD Read/Write control line
LCD_RS	EQU	0	; LCD Register-Select control line

EEFREE	equ	70h	; zacatek volne cast EEPROM - za uzivatelskymi znaky
MAXASA	equ	1Eh	; nejvyssi hodnota ASA
CALNUM	equ	07h	; pocet modu kalibrace
MAXSENS	equ	09h	; maximalni hodnota citlivosti flashmetru


cs	equ	b'11110100'
clk	equ	b'11111000'
reset	equ	b'00000000'
d1	equ	b'00000001'
d2	equ	b'00000010'
break	equ	42h


	ORG	00h
	goto 	start


;-----------------------
; makro pro zobrazeni hodnoty

showval	macro	param
	movf	param,W
	movwf	num
	clrf	charnum
	call	numchard
	call	display
	call	valwait
	endm
	
showvalw macro	param
	movf	param,W
	movwf	num
	clrf	charnum
	call	numchard
	movlw	'W'
	movwf	line2+3
	call	display
	call	valwait
	endm
	
;-----------------------
; makro pro zobrazeni 16-ti bitove hodnoty

showval16	macro	paramh,paraml,id
	movf	paramh,W
	movwf	num
	call	numchar
	movf	paraml,W
	movwf	num
	call	numcharl
	movlw	id
	movwf	num
	call	numchar2
	call	display
	call	valwait
	endm
	
showbr	macro	param
	movlw	'b'     
	movwf	line2	
	movlw	'r'     
	movwf	line2+1	
	movlw	param     
	movwf	line2+2	
	movlw	h'20'   
	movwf	line2+3	
	call	display
	;call	valwait
	movlw	0FFh
	call	msdelay
	endm

;--------------------------
; prevod ASA na 4 znaky pro displej

codeasa1		; prevod prvnich 2 znaku
	addwf	PC,1
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'F2'
	retlw	h'F2'
	retlw	h'F3'
	retlw	h'F4'
	retlw	h'F5'
	retlw	h'F6'
	retlw	h'F8'
	retlw	h'10'
	retlw	h'12'
	retlw	h'16'
	retlw	h'20'
	retlw	h'25'
	retlw	h'32'
	retlw	h'40'
	retlw	h'50'
	retlw	h'64'

codeasa2		; prevod druhych 2 znaku
	addwf	PC,1
	retlw	h'F6'
	retlw	h'F8'
	retlw	h'10'
	retlw	h'12'
	retlw	h'16'
	retlw	h'20'
	retlw	h'25'
	retlw	h'32'
	retlw	h'40'
	retlw	h'50'
	retlw	h'64'
	retlw	h'80'
	retlw	h'00'
	retlw	h'25'
	retlw	h'60'
	retlw	h'00'
	retlw	h'50'
	retlw	h'20'
	retlw	h'00'	
	retlw	h'00'
	retlw	h'40'
	retlw	h'00'
	retlw	h'00'
	retlw	h'50'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	
;--------------------------
; prevod clony na 4 znaky pro displej

codeav21		; prevod prvnich 2 znaku
	addwf	PC,1
	retlw	h'1F'
	retlw	h'1A'
	retlw	h'1A'
	retlw	h'1A'
	retlw	h'2F'
	retlw	h'2A'
	retlw	h'2A'
	retlw	h'3A'
	retlw	h'4F'
	retlw	h'4A'
	retlw	h'5A'
	retlw	h'6A'
	retlw	h'8F'
	retlw	h'9A'
	retlw	h'11'
	retlw	h'13'
	retlw	h'16'
	retlw	h'19'
	retlw	h'22'
	retlw	h'27'
	retlw	h'32'
	retlw	h'38'
	retlw	h'45'
	retlw	h'54'
	retlw	h'64'

codeav22	 	; prevod druhych 2 znaku
	addwf	PC,1
	retlw	h'FF'
	retlw	h'2F'
	retlw	h'4F'
	retlw	h'7F'
	retlw	h'FF'
	retlw	h'4F'
	retlw	h'8F'
	retlw	h'5F'
	retlw	h'FF'
	retlw	h'5F'
	retlw	h'6F'
	retlw	h'7F'
	retlw	h'FF'
	retlw	h'5F'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	
codeav31	; prevod prvnich 2 znaku pro krok 1/3 EV
	addwf	PC,1
	retlw	h'1F'
	retlw	h'1A'
	retlw	h'1A'
	retlw	h'1A'
	retlw	h'1A'
	retlw	h'1A'
	retlw	h'2F'
	retlw	h'2A'
	retlw	h'2A'
	retlw	h'2A'
	retlw	h'3A'
	retlw	h'3A'
	retlw	h'4F'
	retlw	h'4A'
	retlw	h'5F'
	retlw	h'5A'
	retlw	h'6A'
	retlw	h'7A'
	retlw	h'8F'
	retlw	h'9F'
	retlw	h'10'
	retlw	h'11'
	retlw	h'13'
	retlw	h'14'
	retlw	h'16'
	retlw	h'18'
	retlw	h'20'
	retlw	h'22'
	retlw	h'25'
	retlw	h'29'
	retlw	h'32'
	retlw	h'36'
	retlw	h'40'
	retlw	h'45'
	retlw	h'51'
	retlw	h'57'
	retlw	h'64'

codeav32 	; prevod druhych 2 znaku pro krok 1/3 EV
	addwf	PC,1
	retlw	h'FF'
	retlw	h'1F'
	retlw	h'3F'
	retlw	h'4F'
	retlw	h'6F'
	retlw	h'8F'
	retlw	h'FF'
	retlw	h'2F'
	retlw	h'5F'
	retlw	h'8F'
	retlw	h'2F'
	retlw	h'6F'
	retlw	h'FF'
	retlw	h'5F'
	retlw	h'FF'
	retlw	h'6F'
	retlw	h'4F'
	retlw	h'1F'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	
hexascii
	addwf	PC,1
	retlw	h'30'
	retlw	h'31'
	retlw	h'32'
	retlw	h'33'
	retlw	h'34'
	retlw	h'35'
	retlw	h'36'
	retlw	h'37'
	retlw	h'38'
	retlw	h'39'
	retlw	h'2E'
	retlw	h'73'
	retlw	h'20'
	retlw	h'20'
	retlw	h'20'
	retlw	h'20'
	retlw	h'20'		
	
hexascii2
	addwf	PC,1
	retlw	h'30'
	retlw	h'31'
	retlw	h'32'
	retlw	h'33'
	retlw	h'34'
	retlw	h'35'
	retlw	h'36'
	retlw	h'37'
	retlw	h'38'
	retlw	h'39'
	retlw	h'41'
	retlw	h'42'
	retlw	h'43'
	retlw	h'44'
	retlw	h'45'
	retlw	h'46'
	retlw	h'47'			
	
;---------------------------------------------------
; cekani 'dprm' mikrosekund (takt 4 MHz)	
; smycka trva 4 instrukce, takze nejdriv W podelim 4
	
usdelay	rrf	dprm,1	; /2
	rrf	dprm,1	; /2
	movlw	b'00111111'  ; kaslal jsem na prenost bitu pres C flag, proto musim vynulovat horni 2 bity
	andwf	dprm,1
	decf	dprm,1	; cele to deleni trvalo 5 instrukci, takze dprm zmensim o jednu (jako kdyby uz jeden cyklus probehnul)
usloop	nop		; jedna instrukce navic, aby smycka trvala 4 instrukce
	decfsz	dprm,1
	goto 	usloop
	return	

;---------------------------------------------------
; cekani W milisekund (takt 4 MHz)

msdelay	movwf	dprm
	;return
msloop1	movlw	d'249'  ; nejake instrukce zabere velky cyklus, takze misto 250 bude mit mala smycka jenom 249 opakovani
	movwf	tmp
msloop2	nop		; doplnim cyklus na 4 instrukce (250*4=1000us)
	decfsz	tmp,1
	goto 	msloop2
	decfsz	dprm,1
	goto 	msloop1
	return

;---------------------------------------------------
; cekani W setin sekundy (takt 4 MHz)	
	
cdelay 	movwf	tmp1
cloop	movlw	d'10'
	call	msdelay
	decfsz	tmp1,1
	goto 	cloop
	return

delay	movlw	d'50'
	movwf	tmp1
loop1	movlw	d'255'
	movwf	tmp
loop2	decfsz	tmp,1
	goto 	loop2
	decfsz	tmp1,1
	goto 	loop1
	retlw	00h
	
;------------------------------
; 8-bitove deleni
; F1: delenec, W: delitel, F2: vysledek, F1:zbytek
; f3, bit0 : priznak nenuloveho vysledku

div8	clrf	f2
	clrf	f3
d8loop	subwf	f1,1
	btfss   STATUS,C
	goto	d8end
	incf	f2,1
	bsf	f3,0
	goto 	d8loop
d8end	addwf	f1,1
	return
	
;------------------------------
; 8-bitove nasobeni
; F1: nasobeny registr, W: nasobitel, F1: vysledek

mul8	movwf	tmp
	movf	f1,W
m8loop	decfsz	tmp,F
	goto	m8add
	return
m8add	addwf	f1,1
	goto 	m8loop
	
;------------------------------
; deleni 16/8
; F16h,F16l: delenec, W: delitel, F16l vysledek, F2:zbytek

div16x8	clrf	f1
d16loop	subwf	f16l,1
	btfss   STATUS,C
	;goto	d16x8_1
	decfsz	f16h,1
	goto	d16end
d16x8_1	incf	f1,1
	goto 	d16loop
d16end	addwf	f16l,1
	movf	f16l,W
	movwf	f2	; zbytek
	movf	f1,W
	movwf	f16l	; vysledek
	clrf	f16h
	return
	

	
;----------------------
; makro pro zapis hodnoty registru do EEPROM
	
eewrtm	macro	f,adr
	movf	f,W
	movwf	f1
	movlw	adr
	movwf	adr1
	BSF 	PCLATH,3
	call	eewrt
	BCF 	PCLATH,3
	endm
	
;----------------------
; zapis hodnoty registru do EEPROM
; adr1: adresa v EEPROM, f1: prectena hodnota
	
eerd	movf	adr1,W
	bsf	STATUS,RP1  ; banka 2
	movwf	EEADR
	bsf	STATUS,RP0  ; banka 3	
	bcf	EECON1,EEPGD
	bsf	EECON1,RD
	bcf	STATUS,RP0  ; banka 2
	movf	EEDATA,W
	bcf	STATUS,RP1  ; banka 0
	movwf	f1
	return
	
;----------------------
; makro pro cteni hodnoty registru z EEPROM
	
eerdm	macro	f,adr
	movlw	adr
	movwf	adr1
	call	eerd
	movf	f1,W
	movwf	f
	endm
	
;----------------------
; zapise prikaz do LCD se zpozdenim 1ms
	
lcdwr1	movwf	PORTC
	movlw	b'00000000'
	movwf	PORTB
	movlw	b'00000100'
	movwf	PORTB
	movlw	b'00000000'
	movwf	PORTB
	movlw	01h
	call	msdelay
	return
	
;----------------------
; zapise prikaz do LCD se zpozdenim 5ms
	
lcdwr5	movwf	PORTC
	movlw	b'00000000'
	movwf	PORTB
	movlw	b'00000100'
	movwf	PORTB
	movlw	b'00000000'
	movwf	PORTB
	movlw	05h
	call	msdelay	
	return
	
;----------------------
; zapise data do LCD se zpozdenim 1ms
	
lcdwrd1	movwf	PORTC
	movlw	b'00000001'
	movwf	PORTB
	movlw	b'00000101'
	movwf	PORTB
	movlw	b'00000001'
	movwf	PORTB
	movlw	01h
	call	msdelay	
	return
	
;----------------------
; makro pro zapis prikazu do LCD se zpozdenim 1ms	

lcdcmd1	macro 	param
	movlw	param
	call	lcdwr1
	endm
	
;----------------------
; makro pro zapis prikazu do LCD se zpozdenim 5ms	

lcdcmd5	macro 	param
	movlw	param
	call	lcdwr5
	endm	
	
;----------------------
; makro pro zapis dat do LCD se zpozdenim 1ms	

lcddata	macro 	param
	movlw	param
	call	lcdwrd1
	endm	
	
;-----------------------
; makro pro posun kurzoru na pozici POS

lcdmove	macro	pos
	movlw	80h
	addlw	pos
	call	lcdwr1
	endm
	
;-----------------------
; makro pro posun kurzoru na zacatek

lcdhome	macro	
	movlw	d'2'
	call	lcdwr5
	endm
	
;-----------------------
; makro pro vypnuti kurzoru 

;curoff	macro	
;	movlw	h'0C'
;	call	lcdwr1
;	endm	
	
lcdidle	movlw	b'00000011'
	movwf	PORTB	
	movlw	b'11110000'
	movwf	PORTC
	return
	
;--------------------------	
; inicializace LCD displeje
	
initlcd	call	lcdidle
	movlw	d'15'
	call	msdelay	; pockat 15ms
	lcdcmd5	30h	; 8-bitovy mod
	lcdcmd5	30h	; jeste jednou
	lcdcmd5	30h	; a jeste jednou
	lcdcmd5	38h	; 8-bitovy mod, 2 radky, znaky 5x7
	lcdcmd5	06h	; posun kurzoru dopredu
	lcdcmd5	01h	; vymazani displeje
	;lcdcmd5	h'0F'	; zapnuti displeje, kurzor ON
	lcdcmd5	h'0C'	; zapnuti displeje, kurzor OFF
	call	lcdidle
	return
	
;-----------------------
; do generatoru znaku nahraje znak 'blesk'
; (v EEPROM jsou znaky s vyskou max. 5 bodu)
	
loadflashchar
	movf	charadr,W
	movwf	adr1
	
	rlf	adr1,1	; vynasobit charadr osmi
	rlf	adr1,1
	rlf	adr1,1
	movf	adr1,W
	andlw	b'11111000'
	addlw	40h
	call	lcdwr1	; adresa znaku ve znakovem generatoru
	movlw	b'00000010'
	call	lcdwrd1
   	movlw	b'00000100'
   	call	lcdwrd1
   	movlw	b'00001111'
   	call	lcdwrd1
   	movlw	b'00000010'
   	call	lcdwrd1
   	movlw	b'00010100'
   	call	lcdwrd1
   	movlw	b'00011000'
   	call	lcdwrd1
   	movlw	b'00011100'
   	call	lcdwrd1
   	movlw	b'00000000'
   	call	lcdwrd1
	return
	
;--------------------------
; uzivatelsky znak - precte se z EEPROM	
; charadr: pozice v generatoru znaku  W: pozice v EEPROM

loadchar
	movwf	charnum
	iffhi	charnum,h'1E' ; je to primo ASCII, nebude se nahravat z EEPROM
	return
	movf	charadr,W
	movwf	adr1
	
	iffneq	charnum,h'0E' ; znak 'blesk' se nenacita z EEPROM
	goto	nas
	call	loadflashchar
	return
		
nas	rlf	adr1,1	; vynasobit charadr osmi
	rlf	adr1,1
	rlf	adr1,1
	movf	adr1,W
	andlw	b'11111000'
	addlw	40h
	;lcdcmd1	40h
	call	lcdwr1	; adresa znaku ve znakovem generatoru
	;rlf	charnum,1   ; pozici v EEPROM vynasobit 8 -> adresa v EEPROM
	;rlf	charnum,1
	;rlf	charnum,1
	;movf	charnum,W
	;andlw	b'11111000'
	;movwf	charnum
	
	movf	charnum,W
	movwf	f1
	movlw	05h
	call	mul8
	movf	f1,W
	movwf	charnum
	
	movlw	h'05'	; matice znaku v EEPROM ma jen 5 radku
   	movwf	count2
   	;iffneq	charnum,h'4B'   ; neni to prazdny znak - precte se z EEPROM
   	goto	ecread
;clrchar	movlw	h'00'
;	call	lcdwrd1		; prazdny znak - rovnou se vynuluje
;	incf	charnum,1
;	decfsz	count2,1
;	goto	clrchar
;   	return
	   	
ecread 	movf	charnum,W
	bsf	STATUS,RP1  ; banka 2
	movwf	EEADR
	bsf	STATUS,RP0  ; banka 3	
	bcf	EECON1,EEPGD
	bsf	EECON1,RD
	bcf	STATUS,RP0  ; banka 2
	movf	EEDATA,W
	bcf	STATUS,RP1  ; banka 0
	call	lcdwrd1
	incf	charnum,1
	decfsz	count2,1
	goto	ecread
	movlw	b'00000000' ; vymazat zbyvajici 3 radky
	call	lcdwrd1		
	movlw	b'00000000' ; vymazat zbyvajici 3 radky
	call	lcdwrd1
	movlw	b'00000000' ; vymazat zbyvajici 3 radky
	call	lcdwrd1
   	return	
   	
;--------------------------
; prekresleni displeje

display	;goto	secline
	movlw	line1	; adresa 1 znaku na radku
	movwf	FSR	; do ukazatele
	movlw	d'8'	; cyklus bude pro 8 znaku
	movwf	count
	clrf	charadr	; v prvnim radku jsou znaky 0..7 s uzivatelsky nahravanym vzorem
wrchar	movf	INDF,W	
	call	loadchar ; nahrani znaku z EEPROM podle promenne line1
	movlw	80h
	addwf	charadr,W ; pozice znaku na radku
	call	lcdwr1	  ; prikaz LCD "MOVETO"
	movf	charadr,W
	movwf	charnum   ; v charnum bude znak, ktery se zapise do LCD
	iffeq	INDF,h'1F' ; znak 1Fh se nenahrava, je tu zobrazeny pomer denniho a blesk. svetla
	goto	displb1
	ifflo	INDF,h'20' ; znak mensi nez 10h - uzivatelsky znak
	goto	dwr	  ; do LCD zapiseme pozici znaku na radku
	movf	INDF,W	  ; jinak do charnum ulozime primo znak jako ASCII
	movwf	charnum   
dwr	movf	charnum,W
	call	lcdwrd1 ; znak z charnum zapiseme do LCD
displb1	incf	FSR,F
	incf	charadr,F
	decfsz	count,1
	goto	wrchar
; druhy radek	
secline	movlw	line2	; adresa 2 znaku na radku
	movwf	FSR	; do ukazatele
	movlw	d'8'	; cyklus bude pro 8 znaku
	movwf	count
	lcdmove	40h	; posun kurzoru na 1 misto na druhem radku
wrchar2	movf	INDF,W	
	call	lcdwrd1
	incf	FSR,F
	decfsz	count,1
	goto	wrchar2
   	return
   	
;--------------------------
; zobrazeni pomeru denniho a blesk. svetla

showratio
	iffneq	ava,00h	; pokud je malo denniho svetla, pomer se nezobrazuje
	goto	srlb3
	call	clrratio
	return
srlb3	clrf	x
	movlw	d'7'	; cyklus bude pro 7 radku znaku
	movwf	count
	movlw	1Fh
	movwf	line1+1
	movlw	h'0D'     ; uzivatelsky znak "slunicko"
	movwf	line1+2
	movlw	81h
	call	lcdwr1	  ; pomer bude zobrazen ve 2. znaku 1. radku
	movlw	01h
	call	lcdwrd1	 ; pouzijeme znak ASCII 01h
	movlw	48h
	call	lcdwr1	; adresa znaku ve znakovem generatoru
wrratio	ifflof	avf,count ; uz se vykresluje znacka blesk. svetla?
	goto	srlb1
	bsf	x,3
	bsf	x,4
srlb1	ifflof	ava,count ; uz se vykresluje znacka denniho svetla?
	goto	srlb2
	bsf	x,0
	bsf	x,1
srlb2	movf	x,W
	call	lcdwrd1
	decfsz	count,1
	goto	wrratio
	return
   	
;--------------------------
; vymazani displeje

clrdisp	movlw	d'8'	; cyklus bude pro 8 znaku
	movwf	count
	movlw	line1
	movwf	FSR
clr1	movlw	h'20'	; prazdny znak
	movwf	INDF
	incf	FSR,F
	decfsz	count,1
	goto	clr1
	
	movlw	d'8'	; cyklus bude pro 8 znaku
	movwf	count
	movlw	line2
	movwf	FSR
clr2	movlw	d'32'	; znak mezery	
	movwf	INDF
	incf	FSR,F
	decfsz	count,1
	goto	clr2
	return
	
	movlw	d'8'	; cyklus bude pro 8 znaku
	movwf	count
	clrf	charadr
	lcdmove	00h	; posun kurzoru na 1 misto
clr3	movf	charadr,W
	call	lcdwrd1 ; kod znaku = pozice v 1.radku
	incf	charadr,F
	decfsz	count,1
	goto	clr3
	return
	
;--------------------------
; vymazani displeje s prekreslenim	

clrdispr
	call	clrdisp	
	call	display
	return
	
;--------------------------
; vymazani 2. radku displeje

clrline2
	movlw	d'8'	; cyklus bude pro 8 znaku
	movwf	count
	movlw	line2
	movwf	FSR
clr4	movlw	d'32'	; znak mezery	
	movwf	INDF
	incf	FSR,F
	decfsz	count,1
	goto	clr4
	return
	
;--------------------------
; vymazani 2. radku displeje s prekreslenim

clrline2r
	call	clrline2
	call	display
	return

;--------------------------
; prevod citlivosti ASA na znaky 1.radku
   	
asachar	movf	asa,W	    
	call	codeasa1  ; prevod prvnich 2 cislic
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	movwf	line1+4	  ; tisice
	movf	tmp,W
	andlw	0Fh
	movwf	line1+5	  ; stovky
	movf	asa,W
	call	codeasa2  ; prevod druhych 2 cislic
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	movwf	line1+6	  ; desitky
	movf	tmp,W
	andlw	0Fh
	movwf	line1+7	  ; jednotky
	return
	
;--------------------------
; prevod clony na znaky	2. radku

avchar	movf	av,W
	btfss	step,1
	call	codeav21  ; prevod prvnich 2 cislic
	btfss	step,0
	call	codeav31  ; prevod prvnich 2 cislic pro krok 1/3 EV
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii  ; prevod HEX na ASCII
	movwf	line2	  ; tisice
	movf	tmp,W
	andlw	0Fh
	call	hexascii  ; prevod HEX na ASCII
	movwf	line2+1	  ; stovky
	movf	av,W
	btfss	step,1
	call	codeav22  ; prevod druhych 2 cislic
	btfss	step,0
	call	codeav32  ; prevod druhych 2 cislic pro krok 1/3 EV
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii  ; prevod HEX na ASCII
	movwf	line2+2	  ; desitky
	movf	tmp,W
	andlw	0Fh
	call	hexascii  ; prevod HEX na ASCII
	movwf	line2+3	  ; jednotky
	return
	
;--------------------------
; prevod casu na znaky	2. radku

tvchar	movf	tv,W	    
	btfss	step,0
	goto	tchlb1
	;BCF 	PCLATH,4
	BSF 	PCLATH,3
	call	codetv21  ; prevod prvnich 2 cislic
	BCF 	PCLATH,3
tchlb1	btfss	step,1
	goto	tchlb2
	;BCF 	PCLATH,4
	BSF 	PCLATH,3
	call 	codetv31
	;BCF 	PCLATH,4
	BCF 	PCLATH,3
tchlb2	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii  ; prevod HEX na ASCII
	movwf	line2+4	  ; tisice
	movf	tmp,W
	andlw	0Fh
	call	hexascii  ; prevod HEX na ASCII
	movwf	line2+5	  ; stovky
	movf	tv,W
	btfss	step,0
	goto	tchlb3
	;BCF 	PCLATH,4
	BSF 	PCLATH,3
	call	codetv22  ; prevod druhych 2 cislic
	BCF 	PCLATH,3
tchlb3	btfss	step,1
	goto	tchlb4
	;BCF 	PCLATH,4
	BSF 	PCLATH,3
	call 	codetv32
	BCF 	PCLATH,3
tchlb4	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii  ; prevod HEX na ASCII
	movwf	line2+6	  ; desitky
	movf	tmp,W
	andlw	0Fh
	call	hexascii  ; prevod HEX na ASCII
	movwf	line2+7	  ; jednotky
	return
	
;--------------------------
; vymazani pomeru osvetleni v 1. radku

clrratio
	movlw	h'0F'     ; prazdny znak
	movwf	line1+1
	movwf	line1+2
	return		
	
;--------------------------
; vymazani znaku clony (zobrazi "--")

clrav	movlw	h'2D'     ; pomlcka
	movwf	line2	  ; tisice
	movwf	line2+1	  ; stovky
	movlw	h'20'     ; mezera
	movwf	line2+2	  ; desitky
	movwf	line2+3	  ; jednotky
	return	
	
;--------------------------
; vymazani znaku casu (zobrazi "---")

clrtv	movlw	h'20'     ; mezera
	movwf	line2+4	  ; tisice
	movlw	h'2D'     ; pomlcka
	movwf	line2+5	  ; stovky
	movwf	line2+6	  ; desitky
	movwf	line2+7	  ; jednotky
	return		
	
;----------------------------
; prevod registru 'num' na znaky na displeji

numchar	movlw	d'32'
	movwf	line2+2	  ; desitky zatim vymazeme
	movwf	line2+3	  ; jednotky taky
	movf	num,W	    
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2	  ; tisice
	movf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+1	  ; stovky	
	return
	
;------------------	
; prevod citlivosti flashmetru na znaky na displeji	

senschar
	movf	flsens,W
	movwf	num
	call	numchar
	return
	
;----------------
; !!! ladici
	
numchar2	
	movlw	d'32'
	movwf	line2+4	  ; desitky zatim vymazeme
	movwf	line2+5	  ; jednotky taky
	movf	num,W	    
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+6	  ; tisice
	movf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+7	  ; stovky	
	return
	
;----------------------------
; prevod registru 'num' na znaky na displeji (zobrazeni v desitkove soustave)
; v registru 'charnum' je pozice v 2.radku, kde se vysledek zobrazi

numchard
	clrf	f4	; jeste nebyl preveden zadny znak
	;movwf	line2+1	  
	;movwf	line2+2	  
	;movwf	line2+3	  
	movlw	line2
	movwf	FSR
	movf	charnum,W
	addwf	FSR
	movlw	03h
	movwf	count
	movf	num,W
	movwf	f1
	movlw	d'100'
	call	div8
	btfsc	f3,0
	goto	nchdlb1
	btfss	f4,0
	goto	nchd10
nchdlb1	movf	f2,W
	call	hexascii2  ; prevod HEX na ASCII
	movwf	INDF
	incf	FSR,F
	decf	count,F
	bsf	f4,0
nchd10	movlw	d'10'
	call	div8
	btfsc	f3,0
	goto	nchdlb2
	btfss	f4,0
	goto	nchd1
nchdlb2	movf	f2,W
	call	hexascii2  ; prevod HEX na ASCII
	movwf	INDF
	incf	FSR,F
	decf	count,F
nchd1	movf	f1,W
	call	hexascii2  ; prevod HEX na ASCII
	movwf	INDF
	incf	FSR,F
	movlw	d'32'
nchdlb3	movwf	INDF	; vymazene zbyvajici znaky
	incf	FSR,F
	decfsz	count
	goto	nchdlb3
	return
	
;----------------------------
; makro pro prevod registru 'num' na znaky na displeji (zobrazeni v desitkove soustave)
; v 'pos' je pozice v 2.radku, kde se vysledek zobrazi

numchd	macro	pos
	movlw	pos
	movwf	charnum
	call	numchard
	endm
	
;----------------
; !!! ladici
	
numcharl
	movf	num,W	    
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+2	  ; tisice
	movf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+3	  ; stovky	
	return
	
;----------------
; !!! ladici
	
f16char	movf	f16h,W	    
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2	  ; tisice
	movf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+1	  ; stovky	
	movf	f16l,W	    
	movwf	tmp
	swapf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+2	  ; tisice
	movf	tmp,W
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+3	  ; stovky
	return
	
;----------------------------
; prevod poctu zkalibr. bodu na znaky na displeji

nkchar	movlw	d'32'
	movwf	line2+4	  ; desitky zatim vymazeme
	movwf	line2+5	  ; jednotky taky
	movwf	line2+6	  ; jednotky taky
	movf	nk,W	    
	andlw	0Fh
	call	hexascii2  ; prevod HEX na ASCII
	movwf	line2+7	  ; tisice
	return
	
;----------------------------
; prevod hodnoty kroku na znaky na displeji

stepchar	
	movlw	'1'
	movwf	line2
	movlw	'/'
	movwf	line2+1
	movlw	'E'
	movwf	line2+4	  
	movlw	'V'
	movwf	line2+5	  
	movlw	h'0F'     ; prazdny znak
	movwf	line2+6	  
	movwf	line2+7	  
	movwf	line2+3
	btfss	step,0	
	goto	stch3
	movlw	'2'
	movwf	line2+2
	return
stch3	movlw	'3'
	movwf	line2+2
	return
	
;------------------------------
; A/D prevod (trvani cca 50 us)

ad	;movlw	d'12'		; 12 us vzorkovani
	;call	usdelay
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	bsf     ADCON0,GO	; zapnuti prevodu
wait    btfsc   ADCON0,GO       ;Wait for conversion to complete
        goto    wait
        ;movlw	d'24'		; 24 us na prevod musi stacit
	;call	usdelay
        bcf     ADCON0,GO	; ukonceni prevodu
        BSF	STATUS,RP0	; banka 1
	movf	ADRESL,w	; spodni bit vysledku
	BCF	STATUS,RP0	; banka 0
	;movf	ADRESH,w
	movwf	u		; ulozime do promenne u
	return
	movlw	00h
	addwf	ADRESH,w
	btfsc	STATUS,Z	; nenulovy horni byte - doslo k preteceni rozsahu
	return
	movlw	0FFh		
	movwf	u		; do promenne u ulozime maximalni hodnotu
	return
	
;--------------------------
; prevod teploty na napeti
	
adtemp	movlw   b'01001001'  ; Fosc/8 [7-6], A/D ch1 [5-3], a/d on [0]
        movwf   ADCON0
	BSF	STATUS,RP0        
        movlw   b'10000000'  ; A/D: vysledek zarovnany vpravo (cte se z ADRESL), vsechny vstupy jsou analogove
        movwf   ADCON1
        BCF	STATUS,RP0
        movlw	d'10'
        call	msdelay
        call	ad
        movlw   b'01000001'  ; Fosc/8 [7-6], A/D ch0 [5-3], a/d on [0]
        movwf   ADCON0
	BSF	STATUS,RP0        
        movlw   b'10000001'  ; A/D: vysledek zarovnany vpravo (cte se z ADRESL), vsechny vstupy analogove
        movwf   ADCON1
        BCF	STATUS,RP0
        movlw	d'10'
        call	msdelay
        ;movlw	d'245'	; !!! odecist nejakou hodnotu (posunout hodnotu 'u' do oblasti cca 100)
        ;subwf	ad,F
        return
        
;--------------------------
; zmereni napeti baterie
	
adbat	movlw   b'01010001'  ; Fosc/8 [7-6], A/D ch2 [5-3], a/d on [0]
        movwf   ADCON0
	movlw	d'10'
        call	msdelay
        call	ad
        movlw   b'01000001'  ; Fosc/8 [7-6], A/D ch0 [5-3], a/d on [0]
        movwf   ADCON0
	movlw	d'10'
        call	msdelay
        return        
	
;---------------------------
; deleni souctu 16

divacc	movlw	04h
	movwf	tmp
divaccl	rrf	acch,1      
	rrf	acc,1
	bcf	acch,7
	decfsz	tmp,1
	goto 	divaccl
	return
	
;---------------------
; vynulovani promennych pro mereni zablesku
	
flinit	;clrf	mem
	clrf	count
	clrf	acc
	clrf	acch
	clrf	min
	clrf	phase	
	return
	
;------------------------
; !!! pouze kvuli ladeni
	
;kalibr	call	resetcal
;	movlw	d'0'
;	movwf	av
;	movlw	d'133'
;	movwf	u
;	call	addp2
;	movlw	d'2'
;	movwf	av
;	movlw	d'125'
;	movwf	u
;	call	addp2
;	movlw	d'01'
;	movwf	step
;	movlw	d'02'
;	movwf	calmode
;	goto 	endcalib
;	return

;kalibr	call	resetcal
;	movlw	d'225'
;	movwf	sumxxl
;	clrf	sumxxh

;	movlw	h'25'
;	movwf	sumxyl
;	movlw	h'08'
;	movwf	sumxyh

;	movlw	d'15'
;	movwf	sumxl
;	clrf	sumxh

;	movlw	d'237'
;	movwf	sumyl
;	movlw	h'00'
;	movwf	sumyh

;	movlw	d'2'
;	movwf	nk

;	movlw	d'4'
;	movwf	calmode
;	bcf	negbf,0
;	BSF 	PCLATH,3
;	call	countparam
;	BCF 	PCLATH,3
;	return
	
;---------------------------------------------------
; zacatek programu

start	
	BSF	STATUS,RP0
	
	MOVLW	b'11111111'
	movwf   TRISA
	
	MOVLW	b'11111000'
	movwf   TRISB
	
	MOVLW	b'00000000'
	movwf   TRISC
	
	BCF	STATUS,RP0
	
lb1	clrf	mode	; standardni cinnost - mereni
	clrf	mmode	; rezim Av
	clrf	calmode ; neni kalibrace
	clrf	mem
	clrf	count
	clrf	halff
	;call	delay
	movlw	d'106'
	movwf	ae3
	movwf	af3
	movlw	d'159'
	movwf	ae2
	movwf	af2
	movlw	d'59'
	movwf	be
	;movwf	be3
	movwf	bf
	clrf	negbf
	clrf	negb
	;movwf	bf3
	movlw	d'12'
	movwf	asa	; default citlivost 100 ASA
	movlw	d'10'
	movwf	av	; default clona
	
	movlw	d'22'
	movwf	tv	; default cas
	
	movlw   b'01000001'  ; Fosc/8 [7-6], A/D ch0 [5-3], a/d on [0]
        movwf   ADCON0
	BSF	STATUS,RP0        
        movlw   b'10000001'  ; A/D: vysledek zarovnany vpravo (cte se z ADRESL), vsechny vstupy analogove
        movwf   ADCON1
        BCF	STATUS,RP0
        
	clrf	num
	
	call	initlcd
	
	call	clrdisp
	call	display
	
	eerdm	ae2,EEFREE+01h
	eerdm	ae3,EEFREE+02h
	eerdm	be,EEFREE+03h
	
	eerdm	af2,EEFREE+04h
	eerdm	af3,EEFREE+05h
	eerdm	bf,EEFREE+06h
	
	eerdm	at,EEFREE+07h
	eerdm	cetemp,EEFREE+08h
	eerdm	cftemp,EEFREE+09h
	
	eerdm	flsens,EEFREE+0Ah
	eerdm	calbat,EEFREE+0Bh
	
	eerdm	asa,EEFREE+0Ch
	eerdm	negb,EEFREE+0Dh

	eerdm	step,EEFREE

	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
        call	setstep
        
        btfsc	PORTB,5	; stisknuto tlacitko "+" ?
        goto	lb2
        movlw	d'100'	
        call	cdelay	; tlacitko musi byt stisknute 1 sekundu
        btfsc	PORTB,5	; stisknuto tlacitko "+" ?
        goto	lb2
        call	selectcalib
        clrf	calmode
        clrf	mode
        clrf	mmode	; rezim Av
        clrf	calbat	; aby se hned po kalibraci nezobrazovala hlaska o slabem napeti baterie
        
lb2	btfsc	PORTB,4	; stisknuto tlacitko "-" ?
        goto	lb3
        movlw	d'250'	
        call	cdelay	; tlacitko musi byt stisknute 2,5 sekundy
        btfsc	PORTB,4	; stisknuto tlacitko "-" ?
        goto	lb3
        
        BSF 	PCLATH,3
	call	showparam
	BCF 	PCLATH,3
	
lb3	call	testbat
	movlw	d'10'
	btfss	step,0
	movlw	d'15'
	movwf	av	; default clona
	
	movlw	d'24'	
	btfss	step,0
	movlw	d'36'
	movwf	maxav
	
	movlw	d'34'
	btfss	step,0
	movlw	d'51'
	movwf	maxtv
	
br1	call	clrdisp
	call	asachar
	call	avchar
	call	tvchar
	call	display
	
	goto	expo
	
loop	call	ad
	movf	u,W
	movwf	num
	call	numchar
	call	display
	movlw	h'FF'
	call	msdelay
	btfss	PORTB,5	; je zmacknute tlacitko "zmena modu"?
	goto	testfl
	goto	loop		
	
;-----------------------
; osetreni zakmitu + cekani na uvolneni tlacitka "mode"

testbmode
	movlw	d'50'  ; osetreni zakmitu tlacitka
	call	msdelay
tstbut	btfss	BUTMODE	; je zmacknute tlacitko "zmena modu"?
	goto	tstbut
	movlw	d'50'  ; osetreni zakmitu tlacitka
	call	msdelay
	return

;-----------------------
; osetreni zakmitu + 300ms cekani u tlacitka "+"
	
testbplus
	movlw	d'50'  ; osetreni zakmitu tlacitka
	call	msdelay
	movlw	d'250'  
	btfss	PORTB,5	; jeste je stisknuto tlacitko "+" ? 
	call	msdelay ; pockame jeste 0.25 s a pak se muze stisk opakovat	
	return
	
;-----------------------
; osetreni zakmitu + 300ms cekani u tlacitka "+"
	
testbminus
	movlw	d'50'  ; osetreni zakmitu tlacitka
	call	msdelay
	movlw	d'250'  
	btfss	PORTB,4	; jeste je stisknuto tlacitko "-" ? 
	call	msdelay ; pockame jeste 0.25 s a pak se muze stisk opakovat		
	return
	
;--------------------------
; pro testy - cekani na stisk tlacitka "+" 
	
valwait	btfsc	PORTB,5	; neni stisknuto tlacitko "+" ? 
	goto	valwait
	movlw	d'50'  ; osetreni zakmitu tlacitka
	call	msdelay 	
vall1	btfss	PORTB,5	; neni stisknuto tlacitko "+" ? 
	goto	vall1
	return
	
;-----------------------------
; ulozeni a zobrazeni prubehu zablesku
	
;flmem
;	movlw	d'60'
;	movwf	mem
;	movlw	0B0h	; zacatek pole
;	movwf	FSR
;flmad	call	ad
;	
;	movf	u,W
;	movwf	INDF
;	incf	FSR,F
;	decfsz	mem
;	goto	flmad
;flgraph	movlw	d'60'
;	movwf	mem
;	clrf	min
;flg	call	testbplus
;	movlw	0B0h	; zacatek pole
;	movwf	FSR
;	movf	min,W
;	addwf	FSR,F
;	movf	INDF,W
;	movwf	num
;	clrf	charnum
;	call	numchard
;	movf	min,W
;	movwf	num
;	movlw	04h
;	movwf	charnum
;	call	numchard
;	call	display
;	incf	min
;fgtstb	btfsc	PORTB,5	; je zmacknute tlacitko "+"?
;	goto	fgtstb
;	decfsz	mem
;	goto	flg
;	goto 	testfl
	
;-----------------------	
; mod mereni zablesku
	
flash	;goto	chmode
	;showbr	'3'
	movlw	d'22'
	btfss	step,0
	movlw	d'33'
	movwf	tv
	BSF 	PCLATH,3
	btfss	calmode,1
	call	showfl
	BCF 	PCLATH,3
	call	clrav
	btfss	calmode,1
	;call	clrtv
	call	clroverf
	btfss	calmode,1
	call	tvchar
	call	display
	call	testbmode ; cekani na uvolneni tlacitka "mode"
testfl	call 	flinit  ; vynulovani promennych
	;showbr	'4'
	;call	clrdisp
	;call	display
	movlw	d'255'
	movwf	u
floop	btfss	calmode,1
	goto	fllb1
	btfss	BUTMODE	; je zmacknute tlacitko "zmena modu"?
	goto	endfl
	goto	fllb2
fllb1	btfss	BUTMODE	; je zmacknute tlacitko "zmena modu"?
	goto	chmode
	
	btfsc	PORTB,5	; neni stisknuto tlacitko "+" ?
	goto	fltl2	; tak otestujeme tlacitko "-"
	btfsc	calmode,1
	goto	testfl
	ifflof	tv,maxtv ; neni konec rozsahu Tv ?
	incf 	tv,1
	call	tvchar
	call	clrav
	call	clrratio
	call	clroverf
	call	display
	call	testbplus
	goto	testfl
fltl2	btfsc	PORTB,4	; neni stisknuto tlacitko "-" ?
	goto	fllb2	; znovu na zacatek
	btfsc	calmode,1
	goto	testfl
	iffneq	tv,00h ; neni konec rozsahu Tv ?
	decf 	tv,1
	call	tvchar
	call	clrav
	call	clrratio
	call	clroverf
	call	display
	call	testbminus
	goto	testfl
	
	;btfss	PORTB,5	; je stisknuto tlacitko "+" ?
	;goto	flash	; znovu vymazeme display
	;btfss	PORTB,4	; je stisknuto tlacitko "+" ?
	;goto	flash	; znovu vymazeme display
fllb2	movf	u,W
	movwf	mem	; ulozim predchozi mereni do pameti
	call	ad	; nove mereni
	;clrf	u
	;call	uchar
	;call	display
	movf	mem,W	
	subwf	u,W	; odectu predchozi od noveho
	btfss	STATUS,C ; nove mereni je mensi nez prechozi
	goto 	floop
	subwf	flsens,W ; je rozdil vetsi nez nastavena citlivost?
	btfsc	STATUS,C ; ano je - zablesk
	goto 	floop
	movf	mem,W
	movwf	min
	movlw	d'16'
	movwf	fcount	; pocet merenych napeti v zablesku
	;clrf	fcount	; pocet zmerenych napeti v zablesku
	;goto	flmem
	
flmeter	movf	u,W
	addwf	acc,1	  ; prictu zmerenou hodnotu k souctove promenne
	btfsc	STATUS,C  ; pokud doslo k preteceni horniho bitu		
	incf	acch,1	  ; zvetsim hodnoty horniho bajtu
	call	ad	; nove mereni
	decfsz	fcount
	goto	flmeter
	
	btfsc	calmode,1  ; mod kalibrace
	goto	fldiv
	
	;call	divacc	; podelime soucet hodnot mereni konstantou
	;showval	acc
	;showval16	acch,acc,d'01'
	;showval	temp1
	;showval	temp2
	;showval	temp3
	;showval	fcount
	
	call	tempcor	; teplotni kompenzace
	
fltcor	movlw	d'16'
	movwf	fcount	; teplotni korekce, ke vsem merenim (fcount) musime pricist (odecist) korekci
fltcor1	movf	f1,W
	addwf	acc,1	  ; prictu plusovou korekci k souctove promenne
	btfsc	STATUS,C  ; pokud doslo k preteceni horniho bitu		
	incf	acch,1	  ; zvetsim hodnoty horniho bajtu
	movf	f2,W
	subwf	acc,1	  ; prictu plusovou korekci k souctove promenne
	btfss	STATUS,C  ; pokud doslo k preteceni
	decf	acch,1	  ; zvetsim hodnoty horniho bajtu
	decfsz	fcount	  ; zopakujeme pro vsechny mereni v zablesku
	goto	fltcor1
	
	;showval16	acch,acc,d'01'

fldiv	call	divacc	; podelime soucet hodnot mereni konstantou

	;showval	acc
	
	movf	acc,W
	movwf	u
	btfsc	calmode,1  ; mod kalibrace
	retlw	01h	; pridat ke kalibraci

flres	call	setpar  ; vyber parametru a,b podle modu mereni
	
	call	redev	; redukce ev a ASA pri kroku 1/2 EV
	BSF 	PCLATH,3
	call	countx	; vypocet EV podle zavislosti
	BCF 	PCLATH,3
	movf	asar,W	; prictu ASA
	addwf	x,F
	movlw	d'16'
	btfss	step,0
	movlw	d'24'
	subwf	x,F
	clrf	overf
	btfss	STATUS,C
	bsf	overf,2	; nastavit priznak podteceni u flashmetru
	btfsc	overf,2
	clrf	x
	;btfss	STATUS,C
	;clrf	x	; !!! tady se musi zobrazit podteceni
brlb1	movf	x,W
	movwf	avf	; clona od blesk. svetla
	movwf	min
	movlw	d'10'
	call	msdelay	; pockame, az uplne skonci zablesk
		
	clrf	mode	; mod mereni expozice
	movf	mmode,W ; aktualni mod expozimetru do pomoc. promenne
	movwf	min2
	movlw	01h ; nastavime mod Tv
	movwf	mmode
	call	ad
	
	call	tempcor	; teplotni kompenzace
	
	movf	f1,W	; pripocteme prirustek
	addwf	u,F
	movf	f2,W	; odecteme ubytek
	subwf	u,F
	call	countavtv
	movwf	av
	btfsc	overf,0
	clrf	av
	movf	av,W
	movwf	ava
	movf	min2,W ; vratime aktualni mod expozimetru
	movwf	mmode
	incf	mode	; zpatky mod flashmetru
	
	ifflof	avf,ava	; blesk. svetla je mene dez denniho
	goto	fllb3
	movf	avf,W	; jinak dame do Av hodnota avf (clona od blesku)
	movwf	av
	movf	ava,W	; a do min ava (clona od denniho svetla)
	movwf	min
fllb3	BSF 	PCLATH,3
	call	countratio ; spocitame pomer denniho a blesk. svetla
	BCF 	PCLATH,3
	call	showratio ; a zobrazime ho
	BSF 	PCLATH,3
	call	joinavfava
	BCF 	PCLATH,3
	btfss	overf,2	 ; priznak podteceni nastavit pouze tehdy, kdyz  k podteceni doslo u expozimetru i flashmetru
	bcf	overf,0
	call	testavover
	call	avchar
	call	display
	goto	testfl
	
fdisp	;call	displa   ; zobrazeni clony odpovidajici zablesku
	btfsc	PORTB,5	 ; je zmacknute tlacitko "zmena modu"?
	goto	fdisp
	goto	testfl
	;goto	chmode
	btfsc	PORTB,5
	;decfsz	min,1
	goto	fdisp
tstb	btfss	PORTB,5
	goto	tstb
	goto 	testfl
	
endfl	btfss	calmode,1  ; mod kalibrace	
	goto	testfl
	retlw	00h	; ukonceni kalibrace
	
;--------------------------
; test preteceni casu

testtvover
	btfsc	overf,0	; podteceni
	clrf	tv
	iffhif	tv,maxtv
	bsf	overf,1	; nastavit priznak preteceni
	movf	maxtv,W
	btfsc	overf,1	; preteceni
	movwf	tv
	movlw	0Fh
	btfss	overf,0
	goto	tstovrt
	movlw	13h
tstovrt	btfss	overf,1
	goto	tstsett
	movlw	12h
tstsett	movwf	line1+3
	return
	
;--------------------------
; test preteceni clony

testavover
	btfsc	overf,0	; podteceni
	clrf	av
	iffhif	av,maxav
	bsf	overf,1	; nastavit priznak preteceni
	movf	maxav,W
	btfsc	overf,1	; preteceni
	movwf	av
	movlw	0Fh
	btfss	overf,0
	goto	tstovra
	movlw	13h
tstovra	btfss	overf,1
	goto	tstseta
	movlw	12h
tstseta	movwf	line1+3
	return
	
;--------------------------
; vymazani znacky preteceni

clroverf
	movlw	0Fh
	movwf	line1+3
	return	
	
;-------------------------- 	
; redukce napeti podle teploty
; do f1 da prirustek napeti, do f2 ubytek napeti

tempcor	movf	u,W
	movwf	mem	; zapamatujeme si hodnotu napeti
	clrf	f1
	clrf	f2
	iffneq	at,00h	; nebyla provedena kalibrace
	goto	tclb3
	;movf	mem,W
	return
tclb3	call	adtemp
	movf	at,W
	movwf	a1
	clrf	b1
	clrf	rep
	movf	cetemp,W ; teplota pri kalibraci expozimetru
	btfsc	mode,0
	movf	cftemp,W ; teplota pri kalibraci flashmetru
	movwf	caltemp
	iffeqf	u,caltemp ; stejna teplota jako pri kalibraci
	goto	tclb2
	ifflof	u,caltemp ; mensi teplota nez pri kalibraci
	goto	tclb1
	
	movf	caltemp,W ; spocitame rozdil teplot
	subwf	u,F
	BSF 	PCLATH,3
	call	countx	
	BCF 	PCLATH,3
	movf	x,W
	movwf	f1	; prirustek napeti
	clrf	f2
	;addwf	mem
	goto	tclb2
	
tclb1	movf	u,W
	subwf	caltemp,W  ; spocitame rozdil teplot
	movwf	u
	BSF 	PCLATH,3
	call	countx	
	BCF 	PCLATH,3
	movf	x,W
	;subwf	mem
	movwf	f2	; ubytek napeti
	clrf	f1
	
tclb2	movf	mem,W
	movwf	u
	btfss	negb,2	; zaporny parametr at -> musim prehodit prirustek a ubytek
	return
	movf	f1,W
	movwf	tmp
	movf	f2,W
	movwf	f1
	movf	tmp,W
	movwf	f2
	return
	
;--------------------------
; vypocet clony nebo casu podle namereneho napeti

countavtv
	call	setpar  ; vyber parametru a,b podle modu mereni
	call	redev	; redukce ev a ASA pri kroku 1/2 EV
	BSF 	PCLATH,3
	call	countx	; vypocet EV podle zavislosti
	BCF 	PCLATH,3
	movf	asar,W	; prictu ASA
	addwf	x,F
	movf	av,W	; odectu av
	btfsc	mmode,0	; mereni Tv ?
	movf	tv,W	; odectu tv
	subwf	x,F
	btfss	STATUS,C
	bsf	overf,0	; nastavit priznak podteceni
	movf	x,W
	;btfsc	mmode,0	; mereni Av ?
	;goto	cavtve
	;movwf	tv
	return
	
;--------------------------
; mod expozimetru
	
expo	;goto	vypocet
	clrf	chng
	BSF 	PCLATH,3
	call	showexp
	BCF 	PCLATH,3
	call	avchar
	call	tvchar
	call	display
	call	testbmode ; cekani na uvolneni tlacitka "mode"
exp	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
	goto	chmode	
	call	ad
	;movf	u,W
	call	tempcor	; teplotni kompenzace
	;movwf	u
	movf	f1,W	; pripocteme prirustek
	addwf	u,F
	movf	f2,W	; odecteme ubytek
	subwf	u,F
	clrf	overf
	call 	countavtv
	btfsc	mmode,0	; mereni Av ?
	goto	tvm
	movwf	tv
	call	testtvover
	goto	expdisp
tvm	;btfsc	mmode,0	; mereni Tv ?
	movwf	av
	call	testavover
	call	avchar
	
expdisp	call	avchar
	call	tvchar
	
	;call	adtemp
	;movf	u,W
	;movwf	num
	;call	numchar
	
	call	display
	;goto	exp
	movlw	d'20'	; perioda mereni cca 20 x 10 ms = 0.2 s
	movwf	count
dispexp	movlw	d'10'  
	call	msdelay
	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
	goto	chmode	
	btfsc	PORTB,5	; neni stisknuto tlacitko "+" ?
	goto	exptl2	; tak otestujeme tlacitko "-"
	btfsc	chng,0	; v predchozim mereni stisknuto tlacitko "+"
	goto	explb2	; 300 ms se tlacitka nebudou testovat
	btfss	PORTB,4	; soucasne stisknute tlacitko "-"
	goto	chmmode
	bsf	chng,0	; nastavime priznak zmacknuti tlacitka "+"
	btfsc	mmode,0	; mereni Tv
	goto	inctv
	ifflof	av,maxav ; neni konec rozsahu Av ?
	incf	av
	goto	exp
inctv	ifflof	tv,maxtv ; neni konec rozsahu Tv ?
	incf	tv
	goto	exp
exptl2	btfsc	PORTB,4	; neni stisknuto tlacitko "-" ?
	goto	explb1	; znovu na zacatek	
	btfsc	chng,1	; v predchozim mereni stisknuto tlacitko "-"
	goto	explb2	; 300 ms se tlacitka nebudou testovat
	btfss	PORTB,5 ; soucasne stisknute tlacitko "+"
	goto	chmmode 
	bsf	chng,1	; nastavime priznak zmacknuti tlacitka "-"
	btfsc	mmode,0	; mereni Tv
	goto	dectv
	iffneq	av,00h  ; neni konec rozsahu Av ?
	decf	av
	goto	exp
dectv	iffneq	tv,00h  ; neni konec rozsahu Tv ?
	decf	tv
	goto	exp
explb1	clrf	chng	; zrusit priznak zmacknuti tlacitka
explb2	clrf	f1
	btfss	PORTB,5	; test soucasneho stisku tlacitek "+" a "-"
	incf	f1
	btfss	PORTB,4
	incf	f1
	btfsc	f1,1	; obe tlacitka stisknuta - zmena Av/Tv
	goto	chmmode
	decfsz	count,1
	goto	dispexp
	clrf	chng	; zrusit priznak zmacknuti tlacitka
	goto	exp
chmmode			; zmena Av/Tv
	incf	mmode,F
	btfsc	mmode,1
	clrf	mmode
	;movlw	b'00000011'  ; priznak stisku obou tlacitek
	;movwf	chng
	BSF 	PCLATH,3
	call	showexp
	BCF 	PCLATH,3
	call	display
explb3	btfss	PORTB,5	; pockame na konec stisku tlacitek
	goto	explb3
	btfss	PORTB,4
	goto	explb3
	goto	exp
exuflow  	; podteceni
	btfss	mmode,0	; mereni Av ?
	clrf	tv	
	btfsc	mmode,0	; mereni Tv ?
	clrf	av
	
	
;--------------------------
; mod nastaveni citlivosti filmu

setiso	BSF 	PCLATH,3
	call	showiso
	BCF 	PCLATH,3
	call	clrline2r
	call	testbmode ; cekani na uvolneni tlacitka "mode"
	movf	asa,W
	movwf	mem	; zapamatujeme si predchozi hodnotu citlivosti
	;goto	chmode
siso	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
	goto	endiso
	btfsc	PORTB,5	; neni stisknuto tlacitko "+" ?
	goto	tsttl2	; tak otestujeme tlacitko "-"
	ifflo	asa,MAXASA ; neni konec rozsahu ASA ?
	incf 	asa,1
	;incf 	av,1
	;incf 	tv,1
	call	asachar
	;call	avchar
	;call	tvchar
	call	display
	call	testbplus
	goto	siso
tsttl2	btfsc	PORTB,4	; neni stisknuto tlacitko "-" ?
	goto	siso	; znovu na zacatek
	iffneq	asa,00h ; neni konec rozsahu ASA ?
	decf 	asa,1
	call	asachar
	call	display
	;movlw	d'50'	; osetreni zakmitu tlacitka
	;call	msdelay
	;movlw	d'250'  
	;btfss	PORTB,4	; jeste je stisknuto tlacitko "+" ? 
	;call	msdelay ; pockame jeste 0.25 s a pak se muze stisk opakovat
	call	testbminus
	goto	siso
endiso	iffeq	asa,mem	; zmenila se citlivost?
	goto	chmode
	eewrtm	asa,EEFREE+0Ch	; zapiseme do EEPROM
	goto	chmode
	
;-------------------------
; zmena modu cinnosti
	
chmode	incf	mode,1  ; dalsi mod cinnosti
	iffhi	mode,h'02'	; jsem na konci cyklu? 
	clrf	mode	; zase od zacatku
	btfsc	mode,1	; mode=2 - nastaveni citlivosti 
	goto	setiso
	btfsc	mode,0	; mode=1 - flashmetr
	goto	flash	
	goto	expo	; mode=0 - expozimetr
	
;--------------------------
; mod nastaveni kroku

setstep	BSF 	PCLATH,3
	call	showstep
	BCF 	PCLATH,3
	call	stepchar
	call	display
	call	testbmode ; cekani na uvolneni tlacitka "mode"
sstep	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
	goto	wrstep
	btfss	PORTB,5	; stisknuto tlacitko "+" ?
	goto	chstep
	btfss	PORTB,4	; stisknuto tlacitko "-" ?
	goto	chstep
	goto	sstep
chstep	btfss	step,0
       movlw	01h
        btfsc	step,0
        movlw	02h
	movwf	step
	call	stepchar
	call	display
	movlw	d'30'  
	call	cdelay ; pockame 0.3 s a pak se muze stisk opakovat
	goto	sstep
wrstep	eewrtm	step,EEFREE
	return
	
;------------------------------
; vyber parametru podle modu mereni a kroku

setpar	btfsc	mode,0
	goto	fsetpar
	movlw	d'10'   ; hodnota opravy pro krok 1/2 EV
	btfss	step,0
	movlw	d'15'   ; hodnota opravy pro krok 1/3 EV
	movwf	rep	; oprava (kalibrace byla pri 100 ASA a case 1/60 s)
	movf	ae2,W
	btfss	step,0
	movf	ae3,W
	movwf	a1
	movf	be,W
	;btfss	step,0
	;movf	be3,W
	movwf	b1
	clrf	negbf
	return
fsetpar	movf	af2,W
	btfss	step,0
	movf	af3,W
	movwf	a1
	movf	bf,W
	;btfss	step,0
	;movf	bf3,W
	movwf	b1
	movlw	d'8'   ; hodnota opravy pro krok 1/2 EV
	btfss	step,0
	movlw	d'12'   ; hodnota opravy pro krok 1/3 EV
	movwf	rep	; oprava (kalibrace byla pri 100 ASA)
	clrf	negbf
	btfsc	negb,1	; parametr b je zaporny
	bsf	negbf,0
	return
	
;--------------------------
; korekce hodnoty asa a u pro krok 1/2 EV
; citlivost vynasobime 2/3, pokud je zbytek
; po deleni, zvetsime citlivost o 1/2 EV.
; Pri zbytku 1/3 ASA zmetsime hodnotu u o a/2
; pri zbytku 2/3 ASA hodnotu u zvetsime o a/2

redev	movf	asa,W
	movwf	asar
	btfss	step,0	
	return		; krok 1/3 EV, neni potreba redukce
	movf	asa,W
	movwf	f1
	movlw	03h
	call	div8
	movf	f2,W
	movwf	asar
	bcf	STATUS,C
	rlf	asar,F	; vynasobime vysledek deleni 2 - hodnota ASA pro krok 1/2 EV
	iffeq	f1,00h  ; neni zbytek po deleni - cela hodnota ASA
	return
	incf	asar	; zvetsime hodnotu ASA
	movf	f1,W
	movwf	f3
	movf	ae3,W	; expozimetr
	btfsc	mode,0
	movf	af3,W	; flashmetr
	;movwf	f4
	movwf	f1
	movlw	d'50'
	call	div8	; 'a' vydelime 50 (dostaneme a/2, parametr 'a' byl vynasoben 25)
	;movf	af3,W	; flashmetr
	;movwf	f1
	iffhi	f1,25
	incf	f2	; zaokrouhlime vysledek deleni
	movf	f2,W
	btfss	f3,0	; zbytek po deleni ASA je 1/3 EV
	;goto	redev2
	addwf	u,F	; k u pricteme parametr a
	btfss	f3,1	; zbytek po deleni ASA je 2/3 EV
	subwf	u,F	; od u odecteme parametr a
	return
	
;--------------------------
; vynulovani hodnot pro kalibraci

resetcal
	clrf	nk
	clrf	sumxh
	clrf	sumxl
	clrf	sumyh
	clrf	sumyl
	clrf	sumxyh2
	clrf	sumxyh
	clrf	sumxyl
	clrf	sumxxh
	clrf	sumxxl
	return
	
;--------------------------
; kalibrace

calib	call	resetcal
	clrf	chng
	clrf	nk
	clrf	u
	call	clrline2
	btfss	calmode,2 ; kalibrace teploty - nebudeme zobrazovat AV
	call	avchar
	call	nkchar
	call	display
	movlw	d'50'  ; osetreni zakmitu tlacitka
	call	msdelay
calbut	btfss	PORTB,5	; je zmacknute tlacitko "+"?
	goto	calbut
	
	;btfsc	calmode,2 ; kalibrace teploty - osetreni stisku tlacitka 'mode'
	call	testbmode

	;call	testbmode ; cekani na uvolneni tlacitka "mode"
cal	btfsc	calmode,1 ; kalibrace flashmetru
	goto	flcal
	btfsc	BUTMODE	; neni stisknuto tlacitko "Mode" ?
	goto	callb6
	btfsc	calmode,2 ; kalibrace teploty - stiskem "Mode" se kalibrace ukonci
	goto	endcalib
	goto	addpoint
callb6	call	ad
	goto	calchar
	
flcal	iffhi	u,00h	; uz je neco namereno, pouze se zadava clona
	goto	calchar
	call	flash
	movwf	tmp
	btfss	tmp,0
	goto	endcalib
	
	;movf	u,W
	;movwf	num
	;call	numchar2
	
calchar	btfss	calmode,2 ; kalibrace teploty - nebudeme zobrazovat AV
	call	avchar
	call	nkchar
	
caldisp	call	display
	;goto	exp
	movlw	d'30'	; perioda mereni cca 30 x 10 ms = 0.3 s
	movwf	count
dispc	movlw	d'10'  
	call	msdelay
	btfsc	BUTMODE	; neni stisknuto tlacitko "Mode" ?
	goto	callb7
	btfsc	calmode,2 ; kalibrace teploty - stiskem "Mode" se kalibrace ukonci
	goto	endcalib
	goto	addpoint
callb7	btfsc	PORTB,5	; neni stisknuto tlacitko "+" ?
	goto	caltl2	; tak otestujeme tlacitko "-"
	btfsc	chng,0	; v predchozim mereni stisknuto tlacitko "+" nebo "-"
	goto	callb2	; 300 ms se tlacitka nebudou testovat

	btfsc	calmode,2 ; kalibrace teploty - bod se pridava stiskem '+'
	goto	addpoint

	incf	av
	bsf	chng,0	; nastavime priznak zmacknuti tlacitka
	goto	cal
caltl2	btfsc	PORTB,4	; neni stisknuto tlacitko "-" ?
	goto	callb1	; znovu na zacatek	
	btfsc	chng,0	; v predchozim mereni stisknuto tlacitko "+" nebo "-"
	goto	callb2	; 300 ms se tlacitka nebudou testovat
	decf	av
	bsf	chng,0	; nastavime priznak zmacknuti tlacitka
	goto	cal
callb1	clrf	chng	; zrusit priznak zmacknuti tlacitka
callb2	decfsz	count,1
	goto	dispc
	clrf	chng	; zrusit priznak zmacknuti tlacitka
	goto	cal
addpoint
	btfss	calmode,2
	goto	callb4	

	;showval	nk

	iffneq	nk,00h	; prvni bod kalibrace, zapamatujeme si hodnotu
	goto	callb5
	movf	u,W
	movwf	mem
	clrf	min	; pamet predchozi namerene teploty
	clrf	negbf	; priznak zaporneho parametru
callb5	movf	mem,W
	movwf	av
	movf	u,W
	subwf	av,F	; na ose X bude rozdil prvniho a aktualne namereneho napeti na fotodiode (se vzrustajici teplotou napeti klesa)
	call	adtemp	; zmerime teplotu
	ifflof	u,min	; namerena hodnota je mensi nez predchozi - zaporny parametr
	bsf	negbf,0	
	movf	u,W
	movwf	min

	;showval	u
	;showval	av
	;showval	min
	;showval	negbf

callb4	movlw	d'100'	; stisk delsi nez cca 1 s - konec kalibrace
	movwf	count
callb3	movlw	d'10'  
	call	msdelay
	decfsz	count,1
	goto	addp
	goto	endcalib
addp	btfss	BUTMODE	; pockame, dokud je stisknuto tlacitko "Mode" 
	goto	callb3
	
	;showval	av
	;showval	u
	
addp2	movlw	calav	; zacatek pole clon do ukazatele
	movwf	FSR
	movf	nk,W	; pozice podle mereneho bodu
	addwf	FSR,F
	movf	av,W	; pricteme hodnotu clony k sumx
	movwf	INDF	; pridame zmerenou clonu do pole
	addwf	sumxl,F		
	btfsc	STATUS,C
	incf	sumxh,F
	movlw	10h	
	addwf	FSR,F	; posuneme se do pole zmerenych napeti
	movf	u,W	; pricteme hodnotu napeti do sumy
	movwf	INDF	; pridame zmerene napeti do pole
	addwf	sumyl,F		
	btfsc	STATUS,C
	incf	sumyh,F
	movf	av,W	; vynasobime av * av
	movwf	temp4
	movwf	temp6
	clrf	temp3
	clrf	temp5
	BSF 	PCLATH,3
	call	sr_multiply
	BCF 	PCLATH,3
	movf	temp2,W	    ; a pricteme k sumxx
	addwf	sumxxl,F		
	btfsc	STATUS,C
	incf	sumxxh,F
	movf	temp1,W	
	addwf	sumxxh,F
	movf	av,W	; vynasobime u * av
	movwf	temp4
	clrf	temp3
	movf	u,W	
	movwf	temp6
	clrf	temp5
	BSF 	PCLATH,3
	call	sr_multiply
	BCF 	PCLATH,3
	movf	temp2,W	    ; a pricteme k sumxy
	addwf	sumxyl,F		
	btfsc	STATUS,C
	incf	sumxyh,F
	movf	temp1,W	
	addwf	sumxyh,F
	btfsc	STATUS,C
	incf	sumxyh2,F  ; muze to prelizt az do 3. byte
	incf	nk
	call	nkchar
	call	display

	btfsc	calmode,2 ; kalibrace teploty - osetreni stisku tlacitka '+'
	call	testbplus

	clrf	u
	iffhi	nk,07h  ; je zadano 8 bodu - ukoncime kalibraci
	goto	endcalib
	goto	cal	; zpatky na kalibraci dalsiho bodu
	;return
endcalib
	
	;btfsc	calmode,2 ; kalibrace teploty - osetreni stisku tlacitka 'mode'
	;call	testbmode

	iffhi	nk,01h  ; musi byt zadany alespon 2 body
	goto	countp
	ifflo	nk,01h  ; neni zadan ani 1 bod
	return
	btfss	calmode,2 ; kalibrace teploty
	return
	clrf	at
	eewrtm	at,EEFREE+07h
	return
countp	BSF 	PCLATH,3
	call	countparam
	BCF 	PCLATH,3
	btfsc	calmode,2
	clrf	b1
	
	;showval	nk
	;showval	a1
	;showval	b1
	
	btfsc	calmode,2
	return
	
	movf	nk,W	; vypocet linearity - soucet odchylek od zmerenych hodnot
	movwf	count
	movlw	calav	; zacatek pole clon do ukazatele
	movwf	FSR
	clrf	num	; tady bude vysledek
countdiv	
	movf	INDF,W
	movwf	av
	BSF 	PCLATH,3
	call	county	; spocitame hodnoty podle zavislosti
	BCF 	PCLATH,3
	movlw	10h	
	addwf	FSR,F	; posuneme se do pole zmerenych napeti
	;movf	INDF,W
	;movwf	tmp	; zmerena hodnota napeti
	movf	x,W
	subwf	INDF,W	; odecteme spocitanou hodnotu od zmerene
	btfsc	STATUS,C ; zmerena hodnota je mensi, musime ji odecitat od spoctene hodnoty
	goto	adddiv
	movf	INDF,W
	subwf	x,W	; odecteme zmerenou hodnotu od spocitane
adddiv	addwf	num,F
	movlw	0Fh	
	subwf	FSR,F	; posun na nasledujici clonu v poli
	decfsz	count,F	; vypocet pro vsechny body
	goto	countdiv
	
	call	clrline2
	BSF 	PCLATH,3
	call	showsum
	BCF 	PCLATH,3
	numchd	03h	; zobrazime odchylku na displeji
	call	display
	call	testbmode ; cekani na uvolneni tlacitka "mode"
shdwait	btfsc	BUTMODE ; pockame, dokud neni stisknuto tlacitko "mode" ? 
	goto	shdwait
	;movlw	d'50'  ; osetreni zakmitu tlacitka
	;call	msdelay 		
	
	call	adtemp	; zmerime teplotu
	movf	u,W
	btfss	calmode,1	; flashmetr
	goto	exptemp
	movwf	cftemp	; a ulozime
	eewrtm	cftemp,EEFREE+09h
	return
exptemp	movwf	cetemp	; a ulozime
	eewrtm	cetemp,EEFREE+08h
	return
	
;------------------------------
; kalibrace citlivosti flashmetru	

calsens	call	clrline2r
	call	senschar
	call	display
	call	testbmode ; cekani na uvolneni tlacitka "mode"
csloop	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
	goto	endcalsens
	btfsc	PORTB,5	; neni stisknuto tlacitko "+" ?
	goto	cstl2	; tak otestujeme tlacitko "-"
	ifflo	flsens,MAXSENS ; neni konec rozsahu citlivosti ?
	incf 	flsens,1
	call	senschar
	call	display
	call	testbplus
	goto	csloop
cstl2	btfsc	PORTB,4	; neni stisknuto tlacitko "-" ?
	goto	csloop	; znovu na zacatek
	iffneq	flsens,01h ; neni konec rozsahu citlivosti ?
	decf 	flsens,1
	call	senschar
	call	display
	call	testbminus
	goto	csloop
endcalsens
	eewrtm	flsens,EEFREE+0Ah ; zapiseme do EEPROM
	return
	
;------------------------------
; kalibrace nizkeho napeti baterie

calbatt	call	clrline2r
	call	display
	call	testbmode ; cekani na uvolneni tlacitka "mode"
cbloop	btfsc	BUTMODE	; stisknuto tlacitko "Mode" ?
	goto	cbloop
	call	adbat	; zmerime napeti na delici
	movf	u,W
	movwf	calbat	; ulozime do 'calbat'
	eewrtm	calbat,EEFREE+0Bh ; zapiseme do EEPROM
	return	
	
;------------------------------
; kalibrace referencniho napeti

calref	call	clrline2r
	call	display
	call	testbmode ; cekani na uvolneni tlacitka "mode"
crloop	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
	return
	call	ad
	movf	u,W
	movwf	num
	numchd	00h	; zobrazime cislo na zacatku 2. radku
	call	display
	movlw	d'30'	; perioda mereni cca 30 x 10 ms = 0.3 s
	movwf	count
crlb1	movlw	d'10'  
	call	msdelay
	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
	return
	decfsz	count,1
	goto	crlb1
	goto	crloop

;-----------------------------
; zobrazeni modu kalibrace v 1.radku
; W: mod kalibrace

showcalibmode1
	BSF 	PCLATH,3
	call	showcalibt  ; umisteni napisu do pomocneho radku
	BCF 	PCLATH,3
	movlw	08h	    ; zkopirujeme 8 znaku
	movwf	count
	movlw	tline
	movwf	FSR
scl1	movf	INDF,W
	movwf	tmp
	movlw	60h
	subwf	FSR,F
	movf	tmp,W
	movwf	INDF
	movlw	60h
	addwf	FSR,F
	incf	FSR,F
	decfsz	count
	goto	scl1
	return
	
;-----------------------------
; zobrazeni modu kalibrace v 2.radku
; W: mod kalibrace

showcalibmode2
	BSF 	PCLATH,3
	call	showcalibt  ; umisteni napisu do pomocneho radku
	BCF 	PCLATH,3
	movlw	08h	    ; zkopirujeme 8 znaku
	movwf	count
	movlw	tline
	movwf	FSR
scl2	movf	INDF,W
	movwf	tmp
	movlw	58h
	subwf	FSR,F
	movf	tmp,W
	movwf	INDF
	movlw	58h
	addwf	FSR,F
	incf	FSR,F
	decfsz	count
	goto	scl2
	return
	
;-----------------------------
; volba modu kalibrace

selectcalib
	movlw	01h
        movwf	calmode	; kalibrace expozimetru		
selcal  BSF 	PCLATH,3
	call	showcalibr
	BCF 	PCLATH,3
	movf	calmode,W
	call	showcalibmode2	
	call	display
	call	testbplus
	call	testbmode
selcalb	btfss	BUTMODE	; stisknuto tlacitko "Mode" ?
	goto	gocal
	btfsc	PORTB,5	; neni stisknuto tlacitko "+" ?
	goto	selctl2	; tak otestujeme tlacitko "-"
	;ifflo	calmode,CALNUM ; neni konec rozsahu ?
	;incf 	calmode,1
	bcf	STATUS,C
	btfss	calmode,CALNUM-1
	rlf	calmode,F
	movf	calmode,W
	call	showcalibmode2	
	call	display
	call	testbplus
	goto	selcalb
selctl2	btfsc	PORTB,4	; neni stisknuto tlacitko "-" ?
	goto	selcalb	; znovu na zacatek
	;iffneq	calmode,01h ; neni konec rozsahu ?
	;decf 	calmode,1
	btfss	calmode,0
	rrf	calmode,F
	movf	calmode,W
	call	showcalibmode2	
	call	display
	call	testbminus
	goto	selcalb
gocal	btfsc	calmode,CALNUM-1
	return
	movf	calmode,W
	call	showcalibmode1
	call	display
	btfss	calmode,3
	goto	selcal1
	call	calsens
	goto	selcal
selcal1	btfss	calmode,4
	goto	selcal2
	call	calbatt
	goto	selcal
selcal2	btfss	calmode,5
	goto	selcal3
	call	calref
	goto	selcal
selcal3	call	calib
	goto	selcal
	return
	
;--------------------------
; test baterie

testbat	call	adbat
	iffhif	u,calbat ; napeti baterie je vyssi nez pri kalibraci
	return
	BSF 	PCLATH,3
	call	showlowbat  ; umisteni napisu do pomocneho radku
	BCF 	PCLATH,3	
	call	display
	movlw	d'100'
	call	cdelay	; zobrazeni trva 1 sekundu
	call	clrdisp
	return
	
ORG     0x0800	; bank 1

;--------------------------
; prevod casu na 4 znaky pro displej	
	
codetv21		; prevod prvnich 2 znaku
	addwf	PC,1
	retlw	h'F3'
	retlw	h'F2'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'1A'
	retlw	h'FF'
	retlw	h'0A'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'F2'
	retlw	h'F3'
	retlw	h'F5'
	retlw	h'F7'
	retlw	h'10'
	retlw	h'15'
	retlw	h'20'
	retlw	h'30'
	retlw	h'40'

codetv22		; prevod druhych 2 znaku
	addwf	PC,1
	retlw	h'0B'
	retlw	h'2B'
	retlw	h'5B'
	retlw	h'2B'
	retlw	h'8B'
	retlw	h'6B'
	retlw	h'4B'
	retlw	h'3B'
	retlw	h'2B'
	retlw	h'5B'
	retlw	h'1B'
	retlw	h'7B'
	retlw	h'F2'
	retlw	h'F3'
	retlw	h'F4'
	retlw	h'F6'
	retlw	h'F8'
	retlw	h'12'
	retlw	h'15'
	retlw	h'22'
	retlw	h'30'
	retlw	h'45'
	retlw	h'60'
	retlw	h'90'
	retlw	h'25'
	retlw	h'80'
	retlw	h'50'
	retlw	h'50'
	retlw	h'00'
	retlw	h'50'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	
codetv31	; prevod prvnich 2 znaku pro krok 1/3 EV
	addwf	PC,1
	retlw	h'F3'
	retlw	h'F2'
	retlw	h'F2'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'2A'
	retlw	h'FF'
	retlw	h'1A'
	retlw	h'1A'
	retlw	h'FF'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'FF'
	retlw	h'F2'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'FF'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'F1'
	retlw	h'F2'
	retlw	h'F2'
	retlw	h'F3'
	retlw	h'F4'
	retlw	h'F5'
	retlw	h'F6'
	retlw	h'F8'
	retlw	h'10'
	retlw	h'12'
	retlw	h'16'
	retlw	h'20'
	retlw	h'25'
	retlw	h'30'
	retlw	h'40'
	
codetv32	; prevod druhych 2 znaku pro krok 1/3 EV
	addwf	PC,1
	retlw	h'0B'
	retlw	h'5B'
	retlw	h'0B'
	retlw	h'5B'
	retlw	h'2B'
	retlw	h'0B'
	retlw	h'8B'
	retlw	h'6B'
	retlw	h'5B'
	retlw	h'4B'
	retlw	h'3B'
	retlw	h'5B'
	retlw	h'2B'
	retlw	h'6B'
	retlw	h'2B'
	retlw	h'1B' ; 1s
	retlw	h'A3'
	retlw	h'A6'
	retlw	h'F2'
	retlw	h'A5'
	retlw	h'F3'
	retlw	h'F4'
	retlw	h'F5'
	retlw	h'F6'
	retlw	h'F8'
	retlw	h'10'
	retlw	h'12'
	retlw	h'15'
	retlw	h'20'
	retlw	h'25'
	retlw	h'30'
	retlw	h'40'
	retlw	h'50'
	retlw	h'60'
	retlw	h'80'
	retlw	h'00'
	retlw	h'25'
	retlw	h'60'
	retlw	h'00'
	retlw	h'50'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'40'
	retlw	h'00'
	retlw	h'00' ; 1/1000
	retlw	h'50'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	retlw	h'00'
	
;----------------------
; zapis hodnoty registru do EEPROM
; adr1: adresa v EEPROM, f1: zapisovana hodnota

eewrt	;BCF 	PCLATH,3
	;showvalw adr1
	;BSF 	PCLATH,3

	movf	adr1,W
	bsf	STATUS,RP1  ; banka 2
	movwf	EEADR	    ; adresa v EEPROM
	bcf	STATUS,RP1  ; banka 0
	movf	f1,W
	bsf	STATUS,RP1  ; banka 2
	movwf	EEDATA	    ; zapisovana hodnota
	bsf	STATUS,RP0  ; banka 3
	bcf 	EECON1,EEIF 
	bcf 	EECON1,EEPGD
	bsf	EECON1,WREN ; povoleni zapisu
	bcf	EECON1,EEPGD
	MOVLW 	55h 
	MOVWF 	EECON2
	MOVLW 	0AAh 
	MOVWF 	EECON2
	BSF 	EECON1, WR 
wrtest	BTFSC 	EECON1, WR ; cekani na ukonceni zapisu
	goto	wrtest
	bcf	EECON1,WREN ; zakaz zapisu
	bcf	STATUS,RP0
	bcf	STATUS,RP1  ; banka 0
	return
	
;----------------------
; makro pro zapis hodnoty registru do EEPROM
	
eewrtm2	macro	f,adr
	movf	f,W
	movwf	f1
	movlw	adr
	movwf	adr1
	call	eewrt
	endm	
	
countparam	
	btfss	calmode,2 ; parametry pro teplotni zavislost
	clrf	negbf	  ; v pripade teplotny zavislosti se negbf nastavuje uz pri kalibraci
	movf	sumxxl,W  ; vynasobime  sumxx * nk (pocet mereni)
	movwf	temp4
	movf	sumxxh,W
	movwf	temp3
	movf	nk,W
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	
	movf	temp1,W	   ; presun do sumxx
	movwf	sumxxh
	movf	temp2,W	   
	movwf	sumxxl
	
	movf	sumxl,W	   ; vynasobime sumx * sumx
	movwf	temp4
	movwf	temp6
	movf	sumxh,W
	movwf	temp3
	movwf	temp5
	call	sr_multiply
	
	movf	temp2,W   ; vysledek odecteme od (sumxx * nk)
	subwf	sumxxl,F		
	btfss	STATUS,C
	decf	sumxxh,F
	movf	temp1,W
	subwf	sumxxh,F
	
	movf	sumxyl,W  ; vynasobime  sumxy * nk (pocet mereni)
	movwf	temp4
	movf	sumxyh,W
	movwf	temp3
	movf	nk,W
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	
	movf	temp0,W	   ; presun do sumxy
	movwf	sumxyh2
	movf	temp1,W	   
	movwf	sumxyh
	movf	temp2,W	   
	movwf	sumxyl
	
	movf	sumxl,W	; vynasobime sumx * sumy
	movwf	temp4
	movf	sumxh,W
	movwf	temp3
	movf	sumyl,W	
	movwf	temp6
	movf	sumyh,W	
	movwf	temp5
	call	sr_multiply
	
	btfsc	negbf,0
	goto	negsub

	movf	temp2,W  ; odecteme vysledek od sumxy
	subwf	sumxyl,F
	btfsc	STATUS,C
	goto	cplb1
	movlw	01h
	subwf	sumxyh,F
	btfss	STATUS,C
	decf	sumxyh2,F
cplb1	movf	temp1,W 
	subwf	sumxyh,F
	btfss	STATUS,C
	decf	sumxyh2,F
	movf	temp0,W
	subwf	sumxyh2,F
	goto	prepa

negsub	movf	sumxyl,W  ; odecteme vysledek od sumxy
	subwf	temp2,F
	btfsc	STATUS,C
	goto	cplb1n
	movlw	01h
	subwf	temp1,F
	btfss	STATUS,C
	decf	temp0,F
cplb1n	movf	sumxyh,W 
	subwf	temp1,F
	btfss	STATUS,C
	decf	temp0,F
	movf	sumxyh2,W
	subwf	temp0,F
	movf	temp0,W
	movwf	sumxyh2
	movf	temp1,W
	movwf	sumxyh
	movf	temp2,W
	movwf	sumxyl

;negsub	movf	sumxyl,W  ; odecteme sumxy od vysledku
;	subwf	temp2,W
;	movwf	sumxyl
;	btfsc	STATUS,C
;	goto	cplb1n
;	movlw	01h
;	subwf	temp1,F
;	btfss	STATUS,C
;	decf	temp0,F
;cplb1n	movf	sumxyh,W 
;	subwf	temp1,W
;	movwf	sumxyh
;	btfss	STATUS,C
;	decf	temp0,F
;	movf	sumxyh2,W
;	subwf	temp0,F

	
prepa	iffloeq	sumxyh,d'10'  ; vyssi byte musi byt mensi nez 10 - bude se nasobit 25
	goto	counta
	rrf	sumxyh,F      ; vydelime sumxy/2 (jmenovatel)
	rrf	sumxyl,F
	bcf	sumxyh,7
	rrf	sumxxh,F      ; vydelime sumxx/2 (citatel)
	rrf	sumxxl,F
	bcf	sumxxh,7
	goto	prepa
	
counta	movf	sumxyl,W  ; vynasobime citatele 25
	movwf	temp4
	movf	sumxyh,W
	movwf	temp3
	movlw	d'25'	
	movwf	temp6
	clrf	temp5
	call	sr_multiply
		
	movf	temp2,W  ; a podelime sumxx (kde je ted jmenovatel zlomku)
	movwf	temp4
	movf	temp1,W
	movwf	temp3
	movf	sumxxl,W	
	movwf	temp6
	movf	sumxxh,W	
	movwf	temp5
	call	sr_divide
	call	divround
	
parama	movf	temp2,W	; presuneme do a1 
	movwf	a1
	movf	temp1,W
	movwf	a1h
	iffhi	a1h,00h
	goto	errmess	; doslo k chybe - a>255
	
	btfss	calmode,2 ; parametry pro teplotni zavislost
	goto	cplb4
	
	movf	a1,W
	movwf	at
	eewrtm2	at,EEFREE+07h
	bcf	negb,2
	btfsc	negbf,0
	bsf	negb,2
	eewrtm2	negb,EEFREE+0Dh
	return
	
cplb4	movf	sumyl,W  ; vynasobime sumy * 25 (a1 je take vynasobene 25)
	movwf	temp4
	movf	sumyh,W
	movwf	temp3
	movlw	d'25'	
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	
	movf	temp2,W	; a presuneme do b1
	movwf	b1
	movf	temp1,W
	movwf	b1h
	
	movf	a1,W	; vynasobime a1 * sumx
	movwf	temp4
	movf	a1h,W
	movwf	temp3
	movf	sumxl,W	
	movwf	temp6
	movf	sumxh,W	
	movwf	temp5
	call	sr_multiply
	
	movf	b1,W 
	movwf	temp4
	movf	b1h,W 
	movwf	temp3
	
	movf	temp2,W  ; odecteme a1*sumx od b1
	subwf	b1,F		
	btfsc	STATUS,C
	goto	cllb5
	movlw	01h
	subwf	b1h,F
	btfss	STATUS,C
	goto	negb1	; zaporny vysledek odecitani - zaporny parametr b
cllb5	movf	temp1,W
	subwf	b1h,F
	btfss	STATUS,C
	goto	negb1	; zaporny vysledek odecitani - zaporny parametr b
	goto	cllb6	
	
negb1	movf	temp4,W  ; zaporny parametr b - odecteme b1 od a1*sumx
	subwf	temp2,W
	movwf	b1
	btfss	STATUS,C
	decf	temp1,F
	movf	temp3,W
	subwf	temp1,W
	movwf	b1h
	bsf	negbf,0
	
cllb6	movf	nk,W	; nk (pocet mereni) vynasobime 25 (citatel je taky vynasobeny 25)
	movwf	temp4
	clrf	temp3
	movlw	d'25'	
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	
	;movf	temp2,W	  ; zbytek po deleni presuneme do pomocne promenne
	;movwf	f1	
	;rrf	f1,F
	;bcf	f1,7
	;movf	temp1,W
	;movwf	f16h
	
	movf	b1,W	; b1 podelime nk*25 (poctem mereni)
	movwf	temp4
	movf	b1h,W
	movwf	temp3
	movf	temp2,W	
	movwf	temp6
	movf	temp1,W	
	movwf	temp5
	call	sr_divide
	call	divround
	
paramb	movf	temp2,W	  ; presuneme do b1
	movwf	b1
	movf	temp1,W
	movwf	b1h
	
	btfss	calmode,0   
	goto	cplb2
	movf	a1,W
	btfsc	step,0
	movwf	ae2
	btfss	step,0
	movwf	ae3
	movf	b1,W
	movwf	be
	goto	count23
cplb2	movf	a1,W	; flashmeter
	btfsc	step,0
	movwf	af2
	btfss	step,0
	movwf	af3
	movf	b1,W
	movwf	bf
		
count23	movlw	02	; vypocet pro druhy krok, nez pro ktery se kalibruje
	btfss	step,0
	movlw	03
	movwf	temp6
	clrf	temp5
	movf	a1,W
	movwf	temp4
	clrf	temp3
	call	sr_multiply
	movf	temp2,W	
	movwf	temp4
	movf	temp1,W	
	movwf	temp3
	movlw	03	
	btfss	step,0
	movlw	02
	movwf	temp6
	clrf	temp5
	call	sr_divide
	call	divround
	
	btfss	calmode,0
	goto	cplb3

	movf	temp2,W
	btfsc	step,0
	movwf	ae3
	btfss	step,0
	movwf	ae2
	eewrtm2	ae2,EEFREE+01h
	eewrtm2	ae3,EEFREE+02h
	eewrtm2	be,EEFREE+03h
	return
	;goto	wrpar
cplb3	movf	temp2,W	; flashmeter
	btfsc	step,0
	movwf	af3
	btfss	step,0
	movwf	af2
	eewrtm2	af2,EEFREE+04h
	eewrtm2	af3,EEFREE+05h
	eewrtm2	bf,EEFREE+06h
	bcf	negb,1
	btfsc	negbf,0
	bsf	negb,1
	eewrtm2	bf,EEFREE+06h
	eewrtm2	negb,EEFREE+0Dh
	return
	
;------------------------------
; vypocet hodnoty podle zavislosti ev na u
;    25*u-25*b1+rep*a1	
; x=------------------
;           a1

countx	movf	a1,W	; vynasobime rep*a1
	movwf	temp4
	clrf	temp3
	movf	rep,W
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	movf	temp2,W	  ; presuneme do pomocne promenne f16
	movwf	f16l
	movf	temp1,W
	movwf	f16h
	
	movf	u,W	; u vynasobime 25 (a1 je take vynasobena 25)
	movwf	temp4
	clrf	temp3
	movlw	d'25'	
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	
	movf	temp2,W	; pricteme k f16
	addwf	f16l,F
	btfsc	STATUS,C
	incf	f16h,F
	movf	temp1,W	
	addwf	f16h,F
	
	movf	b1,W	; b1 vynasobime 25 (a1 je take vynasobena 25)
	movwf	temp4
	clrf	temp3
	movlw	d'25'	
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	
	btfsc	negbf,0	; zaporny parametr b - musime jej pricist
	goto	addb
	movf	temp2,W	; jinak jej odecteme od f16
	subwf	f16l,F
	;btfss	STATUS,C
	;decf	f16h,F
	btfsc	STATUS,C
	goto	cxlb1
	movlw	01h
	subwf	f16h,F
	btfss	STATUS,C
	goto	cxerr	; doslo k chybe - zaporny vysledek odecitani
cxlb1	movf	temp1,W	
	subwf	f16h,F
	btfss	STATUS,C
	goto	cxerr	; doslo k chybe - zaporny vysledek odecitani
	goto	cxlb2
	
addb	movf	temp2,W	; odecteme od f16
	addwf	f16l,F
	btfsc	STATUS,C
	incf	f16h,F
	movf	temp1,W	
	addwf	f16h,F
	
cxlb2	movf	f16l,W	; podelime a1
	movwf	temp4
	movf	f16h,W	
	movwf	temp3
	movf	a1,W	
	movwf	temp6
	clrf	temp5
	call	sr_divide
	call	divround
	movf	temp2,W
	movwf	x
	return
	
cxerr	clrf	x
	return
	
;------------------------------
; vypocet podle zavislosti u na ev pro kontrolu linearity kalibrace
;     a1*av
; x= ------- +b1
;      25

county	movf	a1,W	; vynasobime a1*av
	movwf	temp4
	clrf	temp3
	movf	av,W
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	
	movf	temp2,W	; vysledek podelime 25
	movwf	temp4
	movf	temp1,W	
	movwf	temp3
	movlw	d'25'	
	movwf	temp6
	clrf	temp5
	call	sr_divide
	call	divround
	movf	temp2,W
	movwf	x
		
	movf	b1,W	; a pricteme (resp. odecteme) b1
	btfss	negbf,0
	addwf	x,F
	btfsc	negbf,0
	subwf	x,F
	return
	
;------------------------------
; slouci clony z bleskoveho a denniho svetla
; av: maximalni clona, min: minimalni clona

joinavfava
	movf	min,W	; vynasobime min*3
	movwf	temp4
	clrf	temp3
	movlw	03h
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	movf	temp2,W  ; a podelime av
	movwf	temp4
	movf	temp1,W
	movwf	temp3
	movf	av,W	
	movwf	temp6
	clrf	temp5
	call	sr_divide
	call	divround
	movf	temp2,W
	addwf	av,F	; vysledek pricteme k av
	return

;-----------------------
; zobrazeni pomeru denniho a blesk. svetla

countratio
	movf	avf,W	; vynasobime avf*7
	movwf	temp4
	clrf	temp3
	movlw	07h
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	movf	temp2,W  ; a podelime av
	movwf	temp4
	movf	temp1,W
	movwf	temp3
	movf	av,W	
	movwf	temp6
	clrf	temp5
	call	sr_divide
	call	divround
	movf	temp2,W	
	movwf	avf
	movf	ava,W	; vynasobime ava*7
	movwf	temp4
	clrf	temp3
	movlw	07h
	movwf	temp6
	clrf	temp5
	call	sr_multiply
	movf	temp2,W  ; a podelime av
	movwf	temp4
	movf	temp1,W
	movwf	temp3
	movf	av,W	
	movwf	temp6
	clrf	temp5
	call	sr_divide
	call	divround
	movf	temp2,W	
	movwf	ava
	return
	
regflag_c       equ     0
regflag_z       equ     1

;------------------------------
; nasobeni 16x16
; (temp0:temp1:temp2) = (temp3:temp4)*(temp5:temp6)

sr_multiply
        ;bcf     temp8,regflag_c
        ;bcf     temp8,regflag_z
        clrf    temp0
        clrf    temp1
        clrf    temp2
        movlw   .16
        movwf   temp7
multiply_binary
        bcf     STATUS,C
        rlf     temp2,1
        rlf     temp1,1
        rlf     temp0,1
        ;btfsc   STATUS,C
        ;bsf     temp8,regflag_c
        bcf     STATUS,C
        rlf     temp4,1
        rlf     temp3,1
        btfss   STATUS,C
        goto    no_multiply
        movf    temp6,0
        addwf   temp2,1
        movlw   .1
        bcf     STATUS,Z
        btfsc   STATUS,C
        addwf   temp1,1
        btfsc   STATUS,Z
        incf	temp0,1
        ;bsf     temp8,regflag_c
        movf    temp5,0
        addwf   temp1,1
        btfsc   STATUS,C
        incf	temp0,1
        ;bsf     temp8,regflag_c
no_multiply
        decfsz  temp7,1
        goto    multiply_binary
        movf    temp1,0
        addwf   temp2,0 ;set zero flag
        bsf     STATUS,C
        btfss   temp8,C
        bcf     STATUS,C
        return
        
;--------------------------
; zaokrouhlit vysledek deleni podle zbytku
	
divround
	rrf	f16h,F      ; vydelime delitele 2
	rrf	f16l,F
	bcf	f16h,7
	movf    f16h,W	  ; porovname horni byte
	subwf	temp3,W
	btfss   STATUS,C  ; zbytek < delitel/2
	return
	btfss   STATUS,Z  
	goto	incresult  ; zbytek > delitel/2
	movf    f16l,W	  ; porovname spodni byte
	subwf	temp4,W
	btfss   STATUS,C  ; zbytek < delitel/2
	return
incresult
	incfsz	temp2,F
	return
	incf	temp1,F
	return
        
;------------------------------
; deleni 16x16
; (temp1:temp2) = (temp3:temp4)/(temp5:temp6)
; (temp3:temp4) = zbytek

sr_divide
	movf    temp6,0 
        movwf	f16l		; presuneme do pomocne promenne kvuli zaokrouhlovani
        movf    temp5,0         ; check dividsion with zero
        movwf	f16h		; presuneme do pomocne promenne kvuli zaokrouhlovani
        iorwf   temp6,0
        btfsc   STATUS,Z
        return
        clrf    temp1
        clrf    temp2
        movlw   .1
        movwf   temp7
shift_btm_left
        btfsc   temp5,7
        goto    div1
        bcf     STATUS,C
        rlf     temp6,1
        rlf     temp5,1
        incf    temp7,1
        goto    shift_btm_left
div1
        bcf     STATUS,C
        rlf     temp2,1
        rlf     temp1,1
        movf    temp6,0
        subwf   temp4,1
        btfsc   STATUS,C
        goto    div2
        movlw   .1
        subwf   temp3,1
        btfsc   STATUS,C
        goto    div2
        incf    temp3,1
        movf    temp6,0
        addwf   temp4,1
        goto    reentr
div2
        movf    temp5,0
        subwf   temp3,1
        btfss   STATUS,C
        goto    less
        bsf     temp2,0
reentr
        bcf     STATUS,C
        rrf     temp5,1
        rrf     temp6,1
        decfsz  temp7,1
        goto    div1
        return
less
        movf    temp6,0
        addwf   temp4,1
        btfsc   STATUS,C
        incf    temp3,1
        movf    temp5,0
        addwf   temp3,1
        goto    reentr
        
;----------------------------
; zkopirovani napisu "EXPO" do 'tline'

showcalib1
	bsf	STATUS,RP0
	movlw	'E'
	movwf	tline
	movlw	'x'
	movwf	tline+1	  
	movlw	'p'
	movwf	tline+2	  
	movlw	'o'
	movwf	tline+3
	movlw	h'0F'     ; prazdny znak
	movwf	tline+4	  
	movwf	tline+5
	movwf	tline+6
	movwf	tline+7	  
	bcf	STATUS,RP0
	return
	
;----------------------------
; zkopirovani napisu "FLASH" do 'tline'

showcalib2
	bsf	STATUS,RP0
	movlw	'F'
	movwf	tline
	movlw	'l'
	movwf	tline+1	  
	movlw	'a'
	movwf	tline+2	  
	movlw	's'
	movwf	tline+3
	movlw	'h'
	movwf	tline+4
	movlw	h'0F'     ; prazdny znak
	movwf	tline+5
	movwf	tline+6
	movwf	tline+7	  
	bcf	STATUS,RP0
	return
	
;----------------------------
; zkopirovani napisu "Teplota" do 'tline'

showcalib3
	bsf	STATUS,RP0
	movlw	'T'
	movwf	tline
	movlw	'e'
	movwf	tline+1	  
	movlw	'p'
	movwf	tline+2	  
	movlw	'l'
	movwf	tline+3	  
	movlw	'o'
	movwf	tline+4
	movlw	't'
	movwf	tline+5
	movlw	'a'
	movwf	tline+6
	movlw	h'0F'     ; prazdny znak
	movwf	tline+7	  
	bcf	STATUS,RP0
	return
	
;----------------------------
; zkopirovani napisu "Citliv." do 'tline'

showcalib4
	bsf	STATUS,RP0
	movlw	'C'
	movwf	tline
	movlw	'i'
	movwf	tline+1	  
	movlw	't'
	movwf	tline+2	  
	movlw	'l'
	movwf	tline+3	  
	movlw	'i'
	movwf	tline+4
	movlw	'v'
	movwf	tline+5
	movlw	'.'
	movwf	tline+6
	movlw	h'0F'     ; prazdny znak
	movwf	tline+7	  
	bcf	STATUS,RP0
	return	
	
;----------------------------
; zkopirovani napisu "Baterie" do 'tline'

showcalib5
	bsf	STATUS,RP0
	movlw	'B'
	movwf	tline
	movlw	'a'
	movwf	tline+1	  
	movlw	't'
	movwf	tline+2	  
	movlw	'e'
	movwf	tline+3	  
	movlw	'r'
	movwf	tline+4
	movlw	'i'
	movwf	tline+5
	movlw	'e'
	movwf	tline+6
	movlw	h'0F'     ; prazdny znak
	movwf	tline+7	  
	bcf	STATUS,RP0
	return		
	
;----------------------------
; zkopirovani napisu "Referenc" do 'tline'

showcalib6
	bsf	STATUS,RP0
	movlw	'R'
	movwf	tline
	movlw	'e'
	movwf	tline+1	  
	movlw	'f'
	movwf	tline+2	  
	movlw	'e'
	movwf	tline+3	  
	movlw	'r'
	movwf	tline+4
	movlw	'e'
	movwf	tline+5
	movlw	'n'
	movwf	tline+6
	movlw	'c'     
	movwf	tline+7	  
	bcf	STATUS,RP0
	return		
	
;----------------------------
; zkopirovani napisu "KONEC" do 'tline'

showcalib7
	bsf	STATUS,RP0
	movlw	'K'
	movwf	tline
	movlw	'o'
	movwf	tline+1	  
	movlw	'n'
	movwf	tline+2	  
	movlw	'e'
	movwf	tline+3	  
	movlw	'c'
	movwf	tline+4
	movlw	h'0F'     ; prazdny znak
	movwf	tline+5
	movwf	tline+6
	movwf	tline+7	  
	bcf	STATUS,RP0
	return
	
;----------------------------
; zobrazeni modu kalibrace (do pomocneho radku)
; W: mod kalibrace

showcalibt
	movwf	tmp
	btfsc	tmp,0
	call	showcalib1
	btfsc	tmp,1
	call	showcalib2
	btfsc	tmp,2
	call	showcalib3
	btfsc	tmp,3
	call	showcalib4
	btfsc	tmp,4
	call	showcalib5
	btfsc	tmp,5
	call	showcalib6
	btfsc	tmp,6
	call	showcalib7
	return
	
;----------------------------
; Zobrazeni napisu "Slaba" a "baterie"

showlowbat
	movlw	'S'
	movwf	line1
	movlw	'l'
	movwf	line1+1	  
	movlw	'a'
	movwf	line1+2	  
	movlw	'b'
	movwf	line1+3	  
	movlw	'a'
	movwf	line1+4
	movlw	h'0F'     ; prazdny znak
	movwf	line1+5
	movwf	line1+6
	movwf	line1+7	  
	movlw	'b'
	movwf	line2
	movlw	'a'
	movwf	line2+1	  
	movlw	't'
	movwf	line2+2	  
	movlw	'e'
	movwf	line2+3	  
	movlw	'r'
	movwf	line2+4
	movlw	'i'
	movwf	line2+5
	movlw	'e'
	movwf	line2+6
	movlw	h'20'     ; prazdny znak
	movwf	line2+7	  
	return
	
;----------------------------
; zobrazeni modu expozimetru v leve casti prvniho radku 

showexp	movlw	h'0D'     ; uzivatelsky znak "slunicko"
	movwf	line1
	movlw	h'0A'     ; uzivatelsky znak "A"
	btfsc	mmode,0	  ; pokud je rezim Tv
	movlw	h'0B'	  ; uzivatelsky znak "T"
	movwf	line1+1
	movlw	h'0C'     ; uzivatelsky znak "v"
	movwf	line1+2
	movlw	h'0F'     ; prazdny znak
	movwf	line1+3	  
	return
	
;----------------------------
; zobrazeni modu flashmetru v leve casti prvniho radku 

showfl	movlw	h'0E'     ; uzivatelsky znak "blesk"
	movwf	line1
	movlw	h'0F'     ; prazdny znak
	movwf	line1+1	  
	movwf	line1+2	  
	movwf	line1+3	  
	return	
	
;----------------------------
; zobrazeni modu nastaveni ISO

showiso	movlw	h'10'
	movwf	line1
	movlw	h'11'
	movwf	line1+1	  
	movlw	h'00'
	movwf	line1+2	  
	movlw	h'0F'     ; prazdny znak
	movwf	line1+3	  
	return
	
;----------------------------
; zobrazeni modu kalibrace

showcalibr
	movlw	'K'
	movwf	line1
	movlw	'A'
	movwf	line1+1	  
	movlw	'L'
	movwf	line1+2	  
	movlw	'I'
	movwf	line1+3
	movlw	'B'
	movwf	line1+4	  
	movlw	'R'
	movwf	line1+5
	movlw	h'0F'     ; prazdny znak
	movwf	line1+6
	movwf	line1+7	  
	return		

;----------------------------
; zobrazeni modu zmeny kroku

showstep
	movlw	'K'
	movwf	line1
	movlw	'r'
	movwf	line1+1	  
	movlw	'o'
	movwf	line1+2	  
	movlw	'k'
	movwf	line1+3
	movlw	h'0F'     ; prazdny znak
	movwf	line1+4
	movwf	line1+5
	movwf	line1+6
	movwf	line1+7
	return		
	
;----------------------------
; zobrazeni sumy odchylek v druhem radku

showsum
	movlw	d'246'  ; znak "suma"
	movwf	line2
	movlw	'd'
	movwf	line2+1	  
	movlw	'='
	movwf	line2+2	  
	movlw	d'32'     ; prazdny znak
	movwf	line2+3
	movwf	line2+4
	movwf	line2+5
	movwf	line2+6
	movwf	line2+7
	return	
	
;----------------------------
; chybova smycka (skoci se do ni pri chybe ve vypoctu)

errmess
	movlw	'C'
	movwf	line1
	movlw	'h'
	movwf	line1+1	  
	movlw	'y'
	movwf	line1+2	  
	movlw	'b'
	movwf	line1+3	  
	movlw	'a'
	movwf	line1+4
	movlw	'!'
	movwf	line1+5
	movlw	h'0F'     ; prazdny znak
	movwf	line1+6
	movwf	line1+7	  
	BCF 	PCLATH,3
	call	clrline2
	call	display
	BSF 	PCLATH,3
erloop	goto	erloop	
	return	
	
;--------------------------
; makro pro zobrazeni parametru ve tvaru
; xyz=param, kde x1=ch1,y=ch2,z=ch3
	
showpar	macro	ch1,ch2,ch3,param,neg
	movlw	ch1
	movwf	line2
	movlw	ch2
	movwf	line2+1
	movlw	ch3
	movwf	line2+2
	movf	param,W
	movwf	num
	movlw	04h
	movwf	charnum	; pozice cisla na 2. radku
	btfsc	neg,0	; zaporna hodnota, pred cislem bude minus
	incf	charnum,F
	BCF 	PCLATH,3
	call	numchard
	movlw	'-'
	btfsc	neg,0	; zaporna hodnota, pred cislem bude minus
	movwf	line2+4
	call	display
	call	valwait
	BSF 	PCLATH,3
	endm
	
;--------------------------
; zobrazeni dulezitych parametru

showparam	
	movlw	'P'
	movwf	line1
	movlw	'a'
	movwf	line1+1	  
	movlw	'r'
	movwf	line1+2	  
	movlw	'a'
	movwf	line1+3	  
	movlw	'm'
	movwf	line1+4
	movlw	'e'
	movwf	line1+5
	movlw	't'
	movwf	line1+6
	movlw	'r'
	movwf	line1+7
	movlw	'='
	movwf	line2+3
	clrf	negbf
	showpar 'a','e','2',ae2,negbf
	showpar 'a','e','3',ae3,negbf
	showpar ' ','b','e',be,negbf
	showpar 'a','f','2',af2,negbf
	showpar 'a','f','3',af3,negbf
	btfsc	negb,1
	bsf	negbf,0
	showpar ' ','b','f',bf,negbf
	clrf	negbf
	btfsc	negb,2
	bsf	negbf,0
	showpar ' ','a','t',at,negbf
	clrf	negbf
	showpar 'c','e','t',cetemp,negbf
	showpar 'c','f','t',cftemp,negbf
	return
	
ORG     0x2100	; EEPROM

	data	b'00000110'
   	data	b'00001001'
   	data	b'00001001'
   	data	b'00001001'
   	data	b'00000110'
   	   	
   	data	b'00000010'
   	data	b'00000110'
   	data	b'00000010'
   	data	b'00000010'
   	data	b'00000111'
   	   	
   	data	b'00001110'
   	data	b'00000001'
   	data	b'00000110'
   	data	b'00001000'
   	data	b'00001111'
   	   	
   	data	b'00001110'
   	data	b'00000001'
   	data	b'00000110'
   	data	b'00000001'
   	data	b'00001110'
   	   	
   	data	b'00000010'
   	data	b'00000100'
   	data	b'00001001'
   	data	b'00001111'
   	data	b'00000001'
   	   	
   	data	b'00001110'
   	data	b'00001000'
   	data	b'00001110'
   	data	b'00000001'
   	data	b'00001110'
   	   	
   	data	b'00000110'
   	data	b'00001000'
   	data	b'00001110'
   	data	b'00001001'
   	data	b'00000110'
   	   	
   	data	b'00001111'
   	data	b'00000001'
   	data	b'00000010'
   	data	b'00000100'
   	data	b'00000100'
   	 	
   	data	b'00000110'
   	data	b'00001001'
   	data	b'00000110'
   	data	b'00001001'
   	data	b'00000110'
   	   	
   	data	b'00000110'
   	data	b'00001001'
   	data	b'00000111'
   	data	b'00000001'
   	data	b'00000110'
   	   	
   	data	b'00000110'
   	data	b'00001001'
   	data	b'00001001'
   	data	b'00001111'
   	data	b'00001001'
   	   	
   	data	b'00000111'
   	data	b'00000010'
   	data	b'00000010'
   	data	b'00000010'
   	data	b'00000010'
   	   	
   	data	b'00000000'
   	data	b'00000000'
   	data	b'00010100'
   	data	b'00010100'
   	data	b'00001000'
   		
	data	b'00010101'
   	data	b'00001110'
   	data	b'00011111'
   	data	b'00001110'
   	data	b'00010101'
   	
   	data	b'00000000'
   	data	b'00000000'
   	data	b'00000000'
   	data	b'00000000'
   	data	b'00000000'
   	
   	data	b'00000000'
   	data	b'00000000'
   	data	b'00000000'
   	data	b'00000000'
   	data	b'00000000'
   	
   	data	b'00000010'
   	data	b'00000010'
   	data	b'00000010'
   	data	b'00000010'
   	data	b'00000010'
   	
   	data	b'00000111'
   	data	b'00001000'
   	data	b'00000110'
   	data	b'00000001'
   	data	b'00001110'
   	
   	data	b'00011111'
   	data	b'00011011'
   	data	b'00010001'
   	data	b'00011011'
   	data	b'00011111'
   	
   	data	b'00011111'
   	data	b'00011111'
   	data	b'00010001'
   	data	b'00011111'
   	data	b'00011111'
   	
ORG     0x2170
   	
   	data	d'01'	; krok (implicitne 1/2 EV)
   	data	d'108'	; ae2
   	data	d'108'	; ae3
   	data	d'59'	; be
   	data	d'108'	; af2
   	data	d'108'	; af3
   	data	d'59'	; bf
   	data	d'00'	; at
   	
   	data	d'00'	; teplota v dobe kalibrace expozimetru
   	data	d'00'	; teplota v dobe kalibrace flashmetru
   	data	d'05'	; citlivost flashmetru
   	data	d'00'	; napeti baterie, ktere uz je brano jako nizke
   	data	d'12'	; citlivost filmu
   	data	d'00'	; priznak zaporneho parametru b
   	data	d'00'
   	data	d'00'
	
	END
